package com.chinaitop;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.web.client.RestTemplate;

import com.github.pagehelper.autoconfigure.PageHelperAutoConfiguration;


@EnableEurekaClient
@EnableFeignClients
@EnableDiscoveryClient
@EnableTransactionManagement
@SpringBootApplication(exclude = PageHelperAutoConfiguration.class)//配置mybatis的配置文件使用，否则报多个分页插件
@MapperScan(basePackages = {"com.chinaitop.depot.*.mapper"})
public class DepotQualitycheckApplication {

	public static void main(String[] args) {
		SpringApplication.run(DepotQualitycheckApplication.class, args);
	}
	
	@Bean
    public RestTemplate restTemplate() {
        return new RestTemplate();
    }

}
