package com.chinaitop;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.feign.AgileHouseFeignClient;
import com.chinaitop.depot.feign.StorageHouseFeignClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;

/**
 * @author qingsong.han
 * @description:
 * @create 2020-07-20 15:16
 */
@Component
public class HystrixClientFallback implements AgileHouseFeignClient, StorageHouseFeignClient {
    private final static Logger logger = LoggerFactory.getLogger(HystrixClientFallback.class);

    @Override
    public JSONObject getList(Integer pageNum, Integer pageSize, String kcswStr, String order) {
        logger.info("feign请求参数:kcswStr= " + kcswStr);
        return null;
    }


    @Override
    public JSONObject getNumberList(Integer pageNum, Integer pageSize,
                                    Integer houseId,
                                    Integer wareId,
                                    Integer orgId) {
        logger.info("feign请求参数: orgId=" + orgId);
        return null;
    }

}
