package com.chinaitop.depot.common;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * @author qingsong.han
 * @description: 公共查询条件(库区编码,仓房编码,货位编码)
 * @create 2024-05-17 16:14
 */
@Data
public class CommonParam implements Serializable {
    private static final long serialVersionUID = 6165640540791400160L;

    @ApiModelProperty(value = "库区编码")
    @NotBlank(message = "库区编码不能为空")
    private String orgId;

    @ApiModelProperty(value = "仓房编码")
    private Integer storehouseId;

    @ApiModelProperty(value = "货位编码")
    private Integer warehouseId;

}
