package com.chinaitop.depot.storage.controller;

import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.storage.model.BusinessFile;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefault;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqDefault;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample;
import com.chinaitop.depot.storage.service.StorageKcglJkqyqApplyDefaultService;
import com.chinaitop.depot.storage.utils.DateJsonValueProcessor;
import com.chinaitop.depot.storage.utils.HTTPUtils;
import com.chinaitop.depot.storage.utils.ParameterUtil;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import net.sf.json.JsonConfig;

@RestController
@RequestMapping(value="/JkqCrkController")
@Api(value= "JkqCrkController", description = "架空期查询类")
public class JkqCrkController {

	
	@Resource
	private StorageKcglJkqyqApplyDefaultService storageKcglJkqyqApplyDefaultService;

	// 获取出入库ip地址
	@Value("${report-Url}")
	private String changeUrl;
	
	@RequestMapping(value="/getApplyList", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
	@ApiOperation(value="架空期申请查询", notes = "支持分页")
	@ApiImplicitParams({
		@ApiImplicitParam(name="pageNum", value = "页码", paramType = "query"),
		@ApiImplicitParam(name="pageSize", value = "每页条数", paramType = "query"),
		@ApiImplicitParam(name="isUpload", value = "状态", paramType = "query"),
		@ApiImplicitParam(name="sqrqA", value = "申请日期始", paramType = "query"),
		@ApiImplicitParam(name="sqrqB", value = "申请日期末", paramType = "query")
	})
	public PageInfo<StorageKcglJkqyqDefault> getApplyList(Integer pageNum, Integer pageSize,HttpServletRequest request,
			String sqrqA, String sqrqB, Integer isUpload) {

		StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
		if (null != pageNum && null != pageSize) {
			PageHelper.startPage(pageNum, pageSize);
		}
		//单位ID
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
		if (null != orgId) {
			criteria.andOrgIdEqualTo(orgId);
		}
		//申请日期
		if(sqrqA != null && !"".equals(sqrqA)) {
			Date starDate = ParameterUtil.string2datetime(sqrqA + " 00:00:00");
			criteria.andSqrqGreaterThanOrEqualTo(starDate);
		}
		if(sqrqB != null && !"".equals(sqrqB)) {
			Date starDate = ParameterUtil.string2datetime(sqrqB + " 23:59:59");
			criteria.andSqrqLessThanOrEqualTo(starDate);
		}
		//状态
		if(isUpload != null && !"".equals(isUpload)) {
			criteria.andIsUploadEqualTo(isUpload);
		}
		example.setOrderByClause("create_date desc");
		List<StorageKcglJkqyqDefault> list = null;
		try {
			list = storageKcglJkqyqApplyDefaultService.findByList(example);
		} catch (Exception e) {
			e.printStackTrace();
		}
		PageInfo<StorageKcglJkqyqDefault> pageInfo = new PageInfo<StorageKcglJkqyqDefault>(list);
		return pageInfo;
	}
	@SuppressWarnings("unchecked")
	@RequestMapping(value = "/add", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
	@ApiOperation(value="新增架空期延期申请", notes = "新增架空期延期申请")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "overFlag", value = "标志位(根据标志位区分新增与修改)", paramType = "form"),
			@ApiImplicitParam(name = "overheadApplyJson", value = "JSON数据对象", paramType = "form"),
			@ApiImplicitParam(name = "overheadAddDcslson", value = "JSON数据对象", paramType = "form")
	})
	public Map<String, Object> add(HttpServletRequest request,Integer overFlag, String overheadApplyJson, String overheadAddDcslson, String fileIds) {
		Map<String, Object> modelMap = new HashMap<String, Object>();
		Date date = new Date();
		String yqsqNo = null;
		String isUpload = null;
		JSONObject overhear = null;
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
		if (null != overheadApplyJson && !"".equals(overheadApplyJson)) {
			overhear = JSONObject.parseObject(overheadApplyJson);
			yqsqNo = (overhear.get("yqsqNo") == null?"":overhear.get("yqsqNo").toString());
			isUpload = (overhear.get("isUpload") == null?"0":overhear.get("isUpload").toString());
		}
		try {
			// JSON字符串转对象
			if(overFlag == 0) {
			ObjectMapper mapper = new ObjectMapper();
			StorageKcglJkqyqDefault storageKcglJkqyqDefault = (StorageKcglJkqyqDefault) mapper.readValue(overheadApplyJson, StorageKcglJkqyqDefault.class);
			storageKcglJkqyqDefault.setCreateDate(date);
			storageKcglJkqyqDefault.setOrgId(orgId);
			storageKcglJkqyqDefault.setIsUpload(0);
			storageKcglJkqyqApplyDefaultService.addDataKcglJkqyqDefault(storageKcglJkqyqDefault);
			StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
			com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
			if (orgId != null && !"".equals(orgId)) {
				criteria.andOrgIdEqualTo(orgId);
			}
			if(yqsqNo !=null && !"".equals(yqsqNo)) {
				criteria.andYqsqNoEqualTo(yqsqNo);
			}
			List<StorageKcglJkqyqDefault> list = storageKcglJkqyqApplyDefaultService.selectByExample(example);
			Integer yqsqId = list.get(0).getId();
			storageKcglJkqyqApplyDefaultService.updateFileByFileIdsAndBid(fileIds, yqsqId, "jkq");
			//添加子表字段
			List<StorageKcglJkqyqApplyDefault> StorageKcglJkqyqApplyDefaultList = null;
			 if (overheadAddDcslson != null) {
				 StorageKcglJkqyqApplyDefaultList = (List<StorageKcglJkqyqApplyDefault>)mapper.readValue(overheadAddDcslson, new TypeReference<List<StorageKcglJkqyqApplyDefault>>(){});
	            }
			// 新增子表.
		        if (StorageKcglJkqyqApplyDefaultList != null && StorageKcglJkqyqApplyDefaultList.size() > 0) {
		            for (StorageKcglJkqyqApplyDefault StorageKcglJkqyqApplyDefault : StorageKcglJkqyqApplyDefaultList) {
		            	StorageKcglJkqyqApplyDefault.setOrgId(orgId);
		            	StorageKcglJkqyqApplyDefault.setUpdatetime(date);
		            	StorageKcglJkqyqApplyDefault.setYqsqNo(yqsqNo);
		            	StorageKcglJkqyqApplyDefault.setIsUpload(Integer.parseInt(isUpload));
		            	storageKcglJkqyqApplyDefaultService.addDataKcglJkqyqDefault1(StorageKcglJkqyqApplyDefault);
		            }
		        }
			}else if(overFlag == 1){
				ObjectMapper mapper = new ObjectMapper();
				StorageKcglJkqyqDefault storageKcglJkqyqDefault = (StorageKcglJkqyqDefault) mapper.readValue(overheadApplyJson, StorageKcglJkqyqDefault.class);
				storageKcglJkqyqDefault.setCreateDate(date);
				storageKcglJkqyqDefault.setOrgId(orgId);
				storageKcglJkqyqApplyDefaultService.updateDataKcglJkqyqDefault(storageKcglJkqyqDefault);
				StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
				com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
				if (orgId != null && !"".equals(orgId)) {
					criteria.andOrgIdEqualTo(orgId);
				}
				if(yqsqNo !=null && !"".equals(yqsqNo)) {
					criteria.andYqsqNoEqualTo(yqsqNo);
				}
				List<StorageKcglJkqyqDefault> list = storageKcglJkqyqApplyDefaultService.selectByExample(example);
				Integer yqsqId = list.get(0).getId();
				storageKcglJkqyqApplyDefaultService.updateFileByFileIdsAndBid(fileIds, yqsqId, "jkq");
				//添加子表字段
				//添加子表字段
				List<StorageKcglJkqyqApplyDefault> StorageKcglJkqyqApplyDefaultList = null;
				 if (overheadAddDcslson != null) {
					 StorageKcglJkqyqApplyDefaultList = (List<StorageKcglJkqyqApplyDefault>)mapper.readValue(overheadAddDcslson, new TypeReference<List<StorageKcglJkqyqApplyDefault>>(){});
		            }
				// 新增子表.
			        if (StorageKcglJkqyqApplyDefaultList != null && StorageKcglJkqyqApplyDefaultList.size() > 0) {
			            for (StorageKcglJkqyqApplyDefault StorageKcglJkqyqApplyDefaul : StorageKcglJkqyqApplyDefaultList) {
			            	StorageKcglJkqyqApplyDefaul.setOrgId(orgId);
			            	StorageKcglJkqyqApplyDefaul.setUpdatetime(date);
			            	StorageKcglJkqyqApplyDefaul.setYqsqNo(yqsqNo);
			            	storageKcglJkqyqApplyDefaultService.updateDataKcglJkqyqDefault1(StorageKcglJkqyqApplyDefaul);
			            }
			        }
			}
			modelMap.put("status", "success");
		} catch (Exception e) {
			e.printStackTrace();
			modelMap.put("status", "error");
			modelMap.put("msg", "保存失败！");
		}
		return modelMap;
	}
	@RequestMapping(value = "/findOverheadData",produces = MediaType.APPLICATION_JSON_VALUE,method = RequestMethod.GET)
	@ApiOperation(value="查询架空期数据列表", notes = "查询架空期信息列表")
	@ApiImplicitParams({
	@ApiImplicitParam(name = "applyNo", value = "架空期延期申请单号", paramType = "query"),
	@ApiImplicitParam(name = "orgId", value = "单位ID", paramType = "query")
	})
	public Map<String, Object> findOverheadData(String applyNo,Integer orgId){
		Map<String, Object> modelMap = new HashMap<String, Object>();
		StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
		if(applyNo != null && !"".equals(applyNo)) {
			criteria.andYqsqNoEqualTo(applyNo);
		}
		if(orgId != null && !"".equals(orgId)) {
			criteria.andOrgIdEqualTo(orgId);
		}
		List<StorageKcglJkqyqDefault> list = storageKcglJkqyqApplyDefaultService.selectByExample(example);
		modelMap.put("DataKcglJkqyqDefaultList", list);
		StorageKcglJkqyqApplyDefaultExample detailExamle = new StorageKcglJkqyqApplyDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample.Criteria detailCriteria = detailExamle.createCriteria();
		if(applyNo != null && !"".equals(applyNo)) {
			detailCriteria.andYqsqNoEqualTo(applyNo);
		}
		if(orgId != null && !"".equals(orgId)) {
			detailCriteria.andOrgIdEqualTo(orgId);
		}
		List<StorageKcglJkqyqApplyDefault> detailList = storageKcglJkqyqApplyDefaultService.selectBy1Example(detailExamle);
		modelMap.put("DataKcglJkqyqDefault1List", detailList);
		List<BusinessFile> fileList= storageKcglJkqyqApplyDefaultService.getByBid(list.get(0).getId(), "jkq", null, null);
		modelMap.put("fileList", fileList);
		return modelMap;
	}
	@SuppressWarnings("unlikely-arg-type")
	@RequestMapping(value = "/removeOverApplyData",produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
	@ApiOperation(value="删除一条延期申请数据", notes = "删除一条延期申请数据")
	@ApiImplicitParams({
	@ApiImplicitParam(name = "yqsqNo", value = "倒仓申请单号", paramType = "query"),
	})
	public Map<String, Object> removeOverApplyData(HttpServletRequest request, String yqsqNo){
		Map<String, Object> map = new HashMap<String, Object>();
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
		try {
			StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
		if(yqsqNo != null && !"".equals(yqsqNo)) {
			criteria.andYqsqNoEqualTo(yqsqNo);
		}
		if(orgId != null && !"".equals(orgId)) {
			criteria.andOrgIdEqualTo(orgId);
		}
		storageKcglJkqyqApplyDefaultService.removeOverData(example);
		StorageKcglJkqyqApplyDefaultExample detailExamle = new StorageKcglJkqyqApplyDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample.Criteria detailCriteria = detailExamle.createCriteria();
		if(yqsqNo != null && !"".equals(yqsqNo)) {
			detailCriteria.andYqsqNoEqualTo(yqsqNo);
		}
		if(orgId != null && !"".equals(orgId)) {
			detailCriteria.andOrgIdEqualTo(orgId);
		}
		storageKcglJkqyqApplyDefaultService.removeOver1Data(detailExamle);
		map.put("status", "success");
		} catch (Exception e) {
			e.printStackTrace();
			map.put("status", "error");
			map.put("msg", "保存失败！");
		}
		return map;
	}
	@SuppressWarnings({ "null" })
	@RequestMapping(value = "/getJkqOveHeadList",produces = MediaType.APPLICATION_JSON_VALUE,method = RequestMethod.GET)
	@ApiOperation(value="查询架空期延期日期", notes = "查询架空期延期日期")
	public PageInfo<Map<String, Object>> getJkqOveHeadList(HttpServletRequest request, Integer pageNum, Integer pageSize){
		Date date = null;
		Date yqDate = null;
		long time1 = 0;
        long time2 = 0;
		Date nowDate = new Date();//获取当前时间
		Calendar cal = Calendar.getInstance();
		Calendar cal1 = Calendar.getInstance();
		SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
		DateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
    	Map<String, Object> map = new HashMap<String, Object>();
    	List<Map<String, Object>> countList = new ArrayList<Map<String, Object>>();
    	List<Map<String, Object>> lastList = new ArrayList<Map<String, Object>>();
    	map.put("orgId", orgId);
    	map.put("executeType", 3156);
        List<Map<String, Object>> list = storageKcglJkqyqApplyDefaultService.getjkqPlanList(map);
        for (Map<String, Object> countMap : list) {
        	countMap.put("orgId", orgId);
        	countList = storageKcglJkqyqApplyDefaultService.getjkqDataDayList(countMap);
        	for (Map<String, Object> lastMap : countList) {
        		Double zcsl = 0.0;
        		Double srsl = 0.0;
        		Integer warningDay = 0;
        		Integer isUpload = 0;
        		long  yqsqTime = 0;
        		if(lastMap != null && !lastMap.isEmpty()){
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("jkqEnd")) {
						String yqtime = (String) lastEntry.getValue();
						try {
							date = format1.parse(yqtime);
							cal.setTime(date);
							if(yqtime.length() != 0) {
								break;
							}
						} catch (ParseException e) {
							e.printStackTrace();
						}
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("overhead_period")) {
						Integer overheadPeriod =(Integer) lastEntry.getValue();
						cal.add(Calendar.MONTH, overheadPeriod);
						break;
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("zcsl")) {
						zcsl =(Double) lastEntry.getValue();
						break;
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("srsl")) {
						srsl =(Double) lastEntry.getValue();
						break;
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("warning_day")) {
						warningDay =(Integer) lastEntry.getValue();
						break;
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
        			if(lastEntry.getKey().equals("is_Upload")) {
        				isUpload =(Integer) lastEntry.getValue();
						break;
					}
				}
        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
					if (lastEntry.getKey().equals("sqyq_time")) {
						String yqwTime =sdf.format(lastEntry.getValue());
						try {
							yqDate = format1.parse(yqwTime);
							cal1.setTime(yqDate);
							yqsqTime = cal1.getTimeInMillis();
							if(yqwTime.length() != 0) {
								break;
							}
						} catch (ParseException e) {
							e.printStackTrace();
						}
						break;
					}
				}
        		try { 
            		String dateString = format.format(nowDate);
                	String timea= format.format(cal.getTime());
    				cal.setTime(sdf.parse(dateString));
    				time1 = cal.getTimeInMillis();
    		        cal.setTime(sdf.parse(timea));
    		        time2 = cal.getTimeInMillis();
    		        long between_days=(time2-time1)/(1000*3600*24);
    		        Integer rengTime = Integer.parseInt(String.valueOf(between_days));
    		        if(isUpload == 2) {
    		        	//isUpload为2表示延期申请上传
    		        	long betdays=(yqsqTime-time1)/(1000*3600*24);
        		        Integer rTime = Integer.parseInt(String.valueOf(betdays));
    		        	if(rTime < warningDay ) {
    		        		if(zcsl > srsl) {
        		        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
        		        					if (lastEntry.getKey().equals("jkqEnd")) {
        	    								lastEntry.setValue(timea);
        	    								lastList.add(lastMap);
        	    								break;
        		        			}
        						}
        		        	}
    		        	}else {
    		        		break;
    		        	}
    		        }else {
    		        	  if(rengTime < warningDay) {
    	    		        	if(zcsl > srsl) {
    	    		        		for (Map.Entry<String, Object> lastEntry : lastMap.entrySet()) {
    	    		        					if (lastEntry.getKey().equals("jkqEnd")) {
    	    	    								lastEntry.setValue(timea);
    	    	    								lastList.add(lastMap);
    	    	    								break;
    	    		        			}
    	    						}
    	    		        	}
    	    		        }
    		        }
    			} catch (ParseException e) {
    				// TODO Auto-generated catch block
    				e.printStackTrace();
    				}
				}
        	}
		}
        PageInfo<Map<String, Object>> pageInfo = new PageInfo<Map<String, Object>>(lastList);
        return pageInfo;
	}
	@RequestMapping(value = "/findSqyqTime",produces = MediaType.APPLICATION_JSON_VALUE,method = RequestMethod.GET)
	@ApiOperation(value="查询架空期延期日期", notes = "查询架空期延期日期")
	@ApiImplicitParams({
	@ApiImplicitParam(name = "modifydate", value = "架空期轮出日期", paramType = "query"),
	@ApiImplicitParam(name = "ch", value = "仓房ID", paramType = "query"),
	@ApiImplicitParam(name = "hwh", value = "货位ID", paramType = "query")
	})
	public PageInfo<StorageKcglJkqyqApplyDefault> findSqyqTime(HttpServletRequest request, Integer ch, Integer hwh){
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
		StorageKcglJkqyqApplyDefaultExample detailExamle = new StorageKcglJkqyqApplyDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample.Criteria detailCriteria = detailExamle.createCriteria();
		if(ch != null && !"".equals(ch)) {
			detailCriteria.andChEqualTo(ch);
		}
		if(hwh != null && !"".equals(hwh)) {
			detailCriteria.andHwhEqualTo(hwh);
		}
		if(orgId != null && !"".equals(orgId)) {
			detailCriteria.andOrgIdEqualTo(orgId);
		}
		detailExamle.setOrderByClause(" updatetime DESC");
		List<StorageKcglJkqyqApplyDefault> detailList = storageKcglJkqyqApplyDefaultService.selectBy1Example(detailExamle);
		PageInfo<StorageKcglJkqyqApplyDefault> pageInfo = new PageInfo<StorageKcglJkqyqApplyDefault>(detailList);
		return pageInfo;
	}
	@SuppressWarnings("unlikely-arg-type")
	@RequestMapping(value = "/present", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
	@ApiOperation(value = "架空期延期申请提交数据到省平台审批", notes = "架空期延期申请提交数据到省平台审批")
	@ApiImplicitParams({ @ApiImplicitParam(name = "yqsqNo", value = "延期申请单号", paramType = "query") })
	public Map<String, Object> present(HttpServletRequest request, String yqsqNo, Integer isUpload) {
		String str = "";
		String jso = "";
		String strs = "";
		JsonConfig config = new JsonConfig(); 
		StorageKcglJkqyqDefault dataKcglJkq = new StorageKcglJkqyqDefault();
		StorageKcglJkqyqApplyDefault dataKcglJkq1 = new StorageKcglJkqyqApplyDefault();
		Map<String, Object> modelMap = new HashMap<String, Object>();
		Integer orgId = (Integer) request.getSession().getAttribute("orgId");
		//主表
		StorageKcglJkqyqDefaultExample example = new StorageKcglJkqyqDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample.Criteria criteria = example.createCriteria();
		//子表
		StorageKcglJkqyqApplyDefaultExample detailExamle = new StorageKcglJkqyqApplyDefaultExample();
		com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample.Criteria detailCriteria = detailExamle.createCriteria();
		if (yqsqNo != null && !"".equals(yqsqNo)) {
			criteria.andYqsqNoEqualTo(yqsqNo);
			detailCriteria.andYqsqNoEqualTo(yqsqNo);
		}
		if (orgId != null && !"".equals(orgId)) {
			criteria.andOrgIdEqualTo(orgId);
			detailCriteria.andOrgIdEqualTo(orgId);
		}
		//获取主表数据
		jso = "{\"DataKcglJkqyqDefault\":[";
		List<StorageKcglJkqyqDefault> list = storageKcglJkqyqApplyDefaultService.selectByExample(example);
		for (StorageKcglJkqyqDefault storageKcglJkqyqDefault : list) {
			config.registerJsonValueProcessor(Date.class, new DateJsonValueProcessor("yyyy-MM-dd"));  
			net.sf.json.JSONObject json = net.sf.json.JSONObject.fromObject(storageKcglJkqyqDefault,config);//将java对象转换为json对象
			strs = strs + json.toString();
		}
		jso = jso + strs + "],";
		//获取子表数据
		List<StorageKcglJkqyqApplyDefault> detailList = storageKcglJkqyqApplyDefaultService.selectBy1Example(detailExamle);
		jso = jso+"\"DataKcglJkqyqDefault1\":[";
		for (StorageKcglJkqyqApplyDefault storageKcglJkqyqApplyDefault : detailList) {
			config.registerJsonValueProcessor(Date.class, new DateJsonValueProcessor("yyyy-MM-dd"));  
			net.sf.json.JSONObject json = net.sf.json.JSONObject.fromObject(storageKcglJkqyqApplyDefault,config);//将java对象转换为json对象
			str = str + json.toString() + ",";
		}
		if(str!=null && str.length()>0) {
			str = str.substring(0, str.length()-1);
		}
		jso = jso + str + "]}";
		try {
		String url = changeUrl+"/business-management/changeStoragehous/saveJcq";
        String count= HTTPUtils.doPost(url,jso);
        if(count.contains("Success") || count.contains("200")){
        	if(isUpload == 0) {
        		dataKcglJkq.setIsUpload(1);
        		dataKcglJkq.setYqsqNo(yqsqNo);
        		storageKcglJkqyqApplyDefaultService.updateJkqStatus(dataKcglJkq);
        		dataKcglJkq1.setIsUpload(1);
        		dataKcglJkq1.setYqsqNo(yqsqNo);
        		storageKcglJkqyqApplyDefaultService.updateJkq1Status(dataKcglJkq1);
        	}
            modelMap.put("status", "success");
            modelMap.put("msg", "成功！");
        }
	 } catch (Exception e){
            e.printStackTrace();
            modelMap.put("status", "error");
            modelMap.put("msg", "保存失败！");
        }
		return modelMap;
	}
	
	@PostMapping(value = "/UpdateJkqStatus")
	@ApiOperation(value = "架空期延期申请省平台审批后修改数据", notes = "架空期延期申请省平台审批后修改数据")
	public String UpdateJkqStatus(String jkqData) {
		String retS = "Success";
		StorageKcglJkqyqApplyDefault detail1 = new StorageKcglJkqyqApplyDefault();
		try {
			ObjectMapper mapper = new ObjectMapper();
			StorageKcglJkqyqDefault storageKcglJkqyqDefault = (StorageKcglJkqyqDefault) mapper.readValue(jkqData, StorageKcglJkqyqDefault.class);
			//修改主表状态
			storageKcglJkqyqApplyDefaultService.updateJkqIsUpload(storageKcglJkqyqDefault);
			detail1.setIsUpload(storageKcglJkqyqDefault.getIsUpload());
			detail1.setYqsqNo(storageKcglJkqyqDefault.getYqsqNo());
			//通过yqsqNo修改子表状态
			storageKcglJkqyqApplyDefaultService.updateJkq1Status(detail1);
		} catch (IOException e) {
			return retS = "error";
		}
		return retS;
	}
}
