package com.chinaitop.depot.storage.controller;

import com.chinaitop.depot.storage.service.StorageStorehouseBusinessService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Map;

/**
 * @Description:
 * @Author: sunhongbing
 * @Date: 2018/5/6
 */
@RestController
@RequestMapping(value = {"/storehouseBusiness"})
@Api(value= "StorageStorehouseBusinessController", description = "仓房业务信息控制类")
public class StorageStorehouseBusinessController {
    @Resource
    private StorageStorehouseBusinessService businessService;

    /**
     * 根据分仓保管账中的仓房名称
     * @return
     */
    @RequestMapping(value = "/getStorehouseListFromBusiness", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
    @ApiOperation(value="仓房业务信息表获取仓房", notes = "该仓房从分仓保管账获得")
    public Map<String, Object> getStorehouseListFromBusiness() throws Exception {
        Map<String, Object> map = null;
        map = businessService.getStorehouseData();
        return map;
    }

    /**
     * 根据分仓保管账中的仓房ID获取货位号
     * @return
     */
    @RequestMapping(value = "/getWarehouseListFromBusiness", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
    @ApiOperation(value="根据仓房业务信息表的仓房ID获取货位号", notes = "该货位从分仓保管账获得")
    public Map<String, Object> getWarehouseListFromBusiness(Integer ch) throws Exception {
        Map<String, Object> map = null;
        if (ch!=null) {
            map = businessService.getWarehouseData(ch);
        }
        return map;
    }

    /**
     * 从分仓保管账中查数据插入到仓房业务表
     */
    @RequestMapping(value = "/insertStorehouseBusinessFromFcbgz", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
    @ApiOperation(value="从分仓保管账中查数据插入到仓房业务表", notes = "从分仓保管账中查数据插入到仓房业务表")
    public void insertStorehouseBusinessFromFcbgz() {
        //从分仓保管账取出仓房和货位以及品种加入到仓房业务信息表中

        businessService.saveStorehouseBusinessFromFcbgz();

    }

    @RequestMapping(value = "/updateAerationTaskStatus", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.POST)
    @ApiOperation(value="更新一个仓房的作业状态", notes = "更新一个仓房的作业状态")
    @ApiImplicitParams({
		@ApiImplicitParam(name = "houseId", value = "仓房ID", paramType = "form"),
		@ApiImplicitParam(name = "wareId", value = "货位ID", paramType = "form"),
		@ApiImplicitParam(name = "orgId", value = "单位ID", paramType = "form"),
		@ApiImplicitParam(name = "aerationStatus", value = "通风状态(ON开启/OFF关闭)", paramType = "form")
	})
    public void updateAerationTaskStatus(Integer houseId, Integer wareId, Integer orgId, String aerationStatus) {
        businessService.updateAerationStatus(houseId, wareId, orgId, aerationStatus);
    }

}
