/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.storage.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 原粮转卡（粮情卡）-货位变更记录表实体
 *
 * @author ZeroLiYi
 * @date  2024/05/24 09:53
 **/
@Getter
@Setter
public class GrainSituationCardWarehouseRecord {

    /** 主键ID */
    @ApiModelProperty(value = "主键ID", position = 1)
    private Integer id;

    /** 创建日期 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "创建日期", position = 2)
    private Date createdate;

    /** 更新人 */
    @ApiModelProperty(value = "更新人", position = 3)
    private String updatename;

    /** 更新日期 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "更新日期", position = 4)
    private Date updatedate;

    /** grain_situation_card的id； */
    @ApiModelProperty(value = "grain_situation_card的id；", position = 5)
    private Integer grainSituationCardId;

    /** 变更时间 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "变更时间", position = 6)
    private Date changeTime;

    /** 新货位号 */
    @ApiModelProperty(value = "新货位号", position = 7)
    private String newWarehouseNumber;

    /** 原货位号 */
    @ApiModelProperty(value = "原货位号", position = 8)
    private String oldWarehouseNumber;

    /** 变更原因 */
    @ApiModelProperty(value = "变更原因", position = 9)
    private String changeReason;
}
