package com.chinaitop.depot.storage.model;

import java.math.BigDecimal;
import java.util.Date;

public class StorageDump {
    private Integer id;

    private Integer ysId;

    private Integer orgId;

    private Integer houseId;

    private Integer wareId;

    private Integer lspz;

    private Integer yLsxz;

    private Integer xLsxz;

    private Integer lsdj;

    private BigDecimal clsl;

    private BigDecimal transferQuantity;

    private String approvalNo;

    private String zjjg;

    private String ysStatus;

    private Date businessCreateTime;

    private Date createTime;

    private String createPerson;

    private Integer isUpload;

    private Date uploadTime;

    private Date updatetime;

    /**
     * 主键ID
     * @return id 主键ID
     */
    public Integer getId() {
        return id;
    }

    /**
     * 主键ID
     * @param id 主键ID
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 验收数据ID
     * @return ys_id 验收数据ID
     */
    public Integer getYsId() {
        return ysId;
    }

    /**
     * 验收数据ID
     * @param ysId 验收数据ID
     */
    public void setYsId(Integer ysId) {
        this.ysId = ysId;
    }

    /**
     * 单位ID
     * @return org_id 单位ID
     */
    public Integer getOrgId() {
        return orgId;
    }

    /**
     * 单位ID
     * @param orgId 单位ID
     */
    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    /**
     * 仓房ID
     * @return house_id 仓房ID
     */
    public Integer getHouseId() {
        return houseId;
    }

    /**
     * 仓房ID
     * @param houseId 仓房ID
     */
    public void setHouseId(Integer houseId) {
        this.houseId = houseId;
    }

    /**
     * 货位ID
     * @return ware_id 货位ID
     */
    public Integer getWareId() {
        return wareId;
    }

    /**
     * 货位ID
     * @param wareId 货位ID
     */
    public void setWareId(Integer wareId) {
        this.wareId = wareId;
    }

    /**
     * 粮食品种
     * @return lspz 粮食品种
     */
    public Integer getLspz() {
        return lspz;
    }

    /**
     * 粮食品种
     * @param lspz 粮食品种
     */
    public void setLspz(Integer lspz) {
        this.lspz = lspz;
    }

    /**
     * 原粮食性质
     * @return y_lsxz 原粮食性质
     */
    public Integer getyLsxz() {
        return yLsxz;
    }

    /**
     * 原粮食性质
     * @param yLsxz 原粮食性质
     */
    public void setyLsxz(Integer yLsxz) {
        this.yLsxz = yLsxz;
    }

    /**
     * 新粮食性质
     * @return x_lsxz 新粮食性质
     */
    public Integer getxLsxz() {
        return xLsxz;
    }

    /**
     * 新粮食性质
     * @param xLsxz 新粮食性质
     */
    public void setxLsxz(Integer xLsxz) {
        this.xLsxz = xLsxz;
    }

    /**
     * 粮食等级
     * @return lsdj 粮食等级
     */
    public Integer getLsdj() {
        return lsdj;
    }

    /**
     * 粮食等级
     * @param lsdj 粮食等级
     */
    public void setLsdj(Integer lsdj) {
        this.lsdj = lsdj;
    }

    /**
     * 储粮数量(单位：公斤)
     * @return clsl 储粮数量(单位：公斤)
     */
    public BigDecimal getClsl() {
        return clsl;
    }

    /**
     * 储粮数量(单位：公斤)
     * @param clsl 储粮数量(单位：公斤)
     */
    public void setClsl(BigDecimal clsl) {
        this.clsl = clsl;
    }

    public BigDecimal getTransferQuantity() {
		return transferQuantity;
	}

	public void setTransferQuantity(BigDecimal transferQuantity) {
		this.transferQuantity = transferQuantity;
	}

	public String getApprovalNo() {
		return approvalNo;
	}

	public void setApprovalNo(String approvalNo) {
		this.approvalNo = approvalNo;
	}

    /**
     * 质检结果
     * @return zjjg 质检结果
     */
    public String getZjjg() {
        return zjjg;
    }

    /**
     * 质检结果
     * @param zjjg 质检结果
     */
    public void setZjjg(String zjjg) {
        this.zjjg = zjjg == null ? null : zjjg.trim();
    }

    /**
     * 验收状态
     * @return ys_status 验收状态
     */
    public String getYsStatus() {
        return ysStatus;
    }

    /**
     * 验收状态
     * @param ysStatus 验收状态
     */
    public void setYsStatus(String ysStatus) {
        this.ysStatus = ysStatus == null ? null : ysStatus.trim();
    }

    /**
     * 业务产生时间
     * @return business_create_time 业务产生时间
     */
    public Date getBusinessCreateTime() {
        return businessCreateTime;
    }

    /**
     * 业务产生时间
     * @param businessCreateTime 业务产生时间
     */
    public void setBusinessCreateTime(Date businessCreateTime) {
        this.businessCreateTime = businessCreateTime;
    }

    /**
     * 创建时间
     * @return create_time 创建时间
     */
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * 创建时间
     * @param createTime 创建时间
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 创建人
     * @return create_person 创建人
     */
    public String getCreatePerson() {
        return createPerson;
    }

    /**
     * 创建人
     * @param createPerson 创建人
     */
    public void setCreatePerson(String createPerson) {
        this.createPerson = createPerson == null ? null : createPerson.trim();
    }

    /**
     * 上传状态(1上传成功,0需上传修改,null未上传)
     * @return is_upload 上传状态(1上传成功,0需上传修改,null未上传)
     */
    public Integer getIsUpload() {
        return isUpload;
    }

    /**
     * 上传状态(1上传成功,0需上传修改,null未上传)
     * @param isUpload 上传状态(1上传成功,0需上传修改,null未上传)
     */
    public void setIsUpload(Integer isUpload) {
        this.isUpload = isUpload;
    }

    /**
     * 上传时间
     * @return upload_time 上传时间
     */
    public Date getUploadTime() {
        return uploadTime;
    }

    /**
     * 上传时间
     * @param uploadTime 上传时间
     */
    public void setUploadTime(Date uploadTime) {
        this.uploadTime = uploadTime;
    }

    /**
     * 
     * @return updatetime 
     */
    public Date getUpdatetime() {
        return updatetime;
    }

    /**
     * 
     * @param updatetime 
     */
    public void setUpdatetime(Date updatetime) {
        this.updatetime = updatetime;
    }
}