package com.chinaitop.depot.storage.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.time.Year;
import java.util.Date;
@Getter
@Setter
public class WarehouseSealingRecord {
    //封仓确认单表
    @ApiModelProperty(value = "仓房id；")
    private Integer basicStorehouseId;
    @ApiModelProperty(value = "廒间id")
    private Integer basicUnitAisleId;
    @ApiModelProperty(value = "货位id")
    private Integer warehouseId;
    @ApiModelProperty(value = "粮食品种；basic_enum的id；粮食品种名称")
    private String grainVarietyName;

    @ApiModelProperty(value = "粮食性质；basic_enum的id；粮食性质名称")
    private String grainNatureName;

    @ApiModelProperty(value = "粮食等级；basic_enum的id；粮食等级名称")
    private String grainGradeName;

    @ApiModelProperty(value = "粮食产地；basic_enum的id；粮食产地名称")
    private String producerName;

    private Integer id;
    private String czbz;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date zhgxsj;
    private String createname;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createdate;
    private String updatename;
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updatedate;
    @ApiModelProperty(value = "封仓单确认单号")
    private String fcqrdh; //封仓单确认单号
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "业务日期")
    private Date ywrq;      //业务日期，格式：yyyy-MM-dd
    @ApiModelProperty(value = "保管员")
    private String bgy;    //保管员
    @ApiModelProperty(value = "粮食品种代码")
    private Integer grainVarietyId; //粮食品种代码
    @ApiModelProperty(value = "粮食性质代码")
    private Integer grainNatureId; //粮食性质代码
    @ApiModelProperty(value = "粮食数量")
    private BigDecimal lssl;
    @ApiModelProperty(value = "粮食等级代码")
    private Integer grainGradeId;
    @ApiModelProperty(value = "粮食产地")
    private Integer grainAreaId;  //货位（油罐）状态为2、3、4时必填
    @ApiModelProperty(value = "收获年度")
    private Year shnd;//收获年度，格式：YYYY，货位（油罐）状态为2、3、4时必填
    @ApiModelProperty(value = "申请人")
    private String sqr;  //申请人
    @ApiModelProperty(value = "部门审核")
    private String bmsh;  //部门审核
    @ApiModelProperty(value = "单位领导审核")
    private String dwldsh;  //单位领导审核
    @ApiModelProperty(value = "备注")
    private String bz;      //备注
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "入仓日期；第一车粮食入仓时间；")
    private Date rcsj;
    @ApiModelProperty(value = "管理方式 01 直储；02 代储；03 租仓；04 委托；")
    private  String glfs;
    @ApiModelProperty(value = "状态 0：保存；1：生成粮情卡；")
    private Integer status;
    @ApiModelProperty(value = "仓房名称")
    private String storehouseName;
    @ApiModelProperty(value = "廒间名称")
    private String ajmc; //廒间名称
    @ApiModelProperty(value = "货位名称")
    private String warehouseName;
    @ApiModelProperty(value = "收获年度名称")
    private String shndName;
    @ApiModelProperty(value = "库区ID")
    private Integer orgId;

}