package com.chinaitop.depot.storage.model.vo;

import com.chinaitop.depot.qualityControl.model.BusinessQcQualityInspection;
import com.chinaitop.depot.storage.model.GrainSituationCard;
import com.chinaitop.depot.storage.model.GrainSituationCardWarehouseRecord;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
public class GrainSituationCardVO extends GrainSituationCard {
    @ApiModelProperty(value = "库区名称")
    private String orgName;
    @ApiModelProperty(value = "仓房名称")
    private String storehouseName;
    @ApiModelProperty(value = "货位名称")
    private String warehouseName;
    @ApiModelProperty(value = "粮食品种")
    private String grainVarietyName;
    @ApiModelProperty(value = "廒间名称")
    private String ajmc;
    @ApiModelProperty(value = "粮食性质")
    private String grainNatureName;
    @ApiModelProperty(value = "粮食等级")
    private String grainGradeName;
    @ApiModelProperty(value = "粮食产地")
    private String producerName;
    @ApiModelProperty(value = "收获年度名称")
    private String shndName;
    @ApiModelProperty(value = "有无粮情检测设施")
    private Integer temperatureMeasureTypeOld;
    @ApiModelProperty(value = "保管方式名称")
    private String keepingWayName;

    @ApiModelProperty(value = "通风方式名称")
    private String drafttypeName;
    @ApiModelProperty(value = "仓房类型名称")
    private String storehouseTypeName;

    @ApiModelProperty(value = "质检信息检测记录")
    List<BusinessQcQualityInspection> businessQcQualityInspectionList;

    @ApiModelProperty(value = "货位变更")
    List<GrainSituationCardWarehouseRecord> grainSituationCardWarehouseRecordList;


}
