/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.storage.service;


import com.chinaitop.depot.qualityControl.model.BusinessQcQualityInspection;
import com.chinaitop.depot.storage.model.GrainSituationCard;
import com.chinaitop.depot.storage.model.vo.GrainSituationCardVO;
import com.chinaitop.depot.storage.param.GrainSituationCardIdParam;
import com.chinaitop.depot.storage.param.GrainSituationCardPageParam;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 原粮转卡（粮情卡）Service接口
 *
 * @author ZeroLiYi
 * @date  2024/05/24 09:50
 **/
public interface GrainSituationCardService {

    /**
     * 获取原粮转卡（粮情卡）分页
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     */
    List<GrainSituationCard> page(GrainSituationCardPageParam grainSituationCardPageParam);

    /**
     * 获取原粮转卡（粮情卡）详情
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     **/
    GrainSituationCardVO detail(GrainSituationCardIdParam grainSituationCardIdParam);;

    /**
     * 查询质检报告单
     * @param warehouseId
     * @return
     */
    List<BusinessQcQualityInspection> getQualityInspectionFindByWarehouseId(Integer warehouseId);

    Map<String, Object> add(GrainSituationCardVO grainSituationCardVO);

    Map<String, Object> exportdetail(GrainSituationCardIdParam grainSituationCardIdParam) throws IOException, NoSuchFieldException;


    /**
     * 添加原粮转卡（粮情卡）
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     */
    //void add(GrainSituationCardAddParam grainSituationCardAddParam);

    /**
     * 编辑原粮转卡（粮情卡）
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     */
    //void edit(GrainSituationCardEditParam grainSituationCardEditParam);

    /**
     * 删除原粮转卡（粮情卡）
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     */
    //void delete(List<GrainSituationCardIdParam> grainSituationCardIdParamList);

    /**
     * 获取原粮转卡（粮情卡）详情
     *
     * @author ZeroLiYi
     * @date  2024/05/24 09:50
     */
   // GrainSituationCard detail(GrainSituationCardIdParam grainSituationCardIdParam);


}
