package com.chinaitop.depot.storage.service;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.chinaitop.depot.storage.model.TCcdata;
import com.chinaitop.depot.storage.model.TCcdataExample;
import com.chinaitop.depot.storage.model.TCcvalue;
import com.chinaitop.depot.unissoft.model.ResponseEntity;

public interface InsectPestDetectionService {

    /**
     * 列表
     *
     * @param iBeginTdh
     * @param iEndTdh
     * @return
     */
    List<TCcdata> getList(String vCfCode, Integer iBeginTdh, Integer iEndTdh,String createTime,String orgId);

    /**
     * 图表展示
     *
     * @param cfCode
     * @param searchStartDate
     * @param searchEndDate
     * @return
     */
    ResponseEntity getByCfCode(String cfCode, String searchStartDate, String searchEndDate);

    /**
     * 获取每个仓房数据
     *
     * @return
     */
    Map<String, Map<String, Object>> getByCfCodes(Map<String, Object> mapDate);

    //批量添加检测虫害数据
    void insertBatch(List<TCcdata> tCcdata);

    //根据设备code和时间查询虫害检测数据
    List<TCcdata> getByCodeAndTimes(List<String> cDcsCodes, List<Date> cTimes, List<Integer> tdhs);

    TCcvalue getOneByCfCode(String orgId, String vCfCode);

    /**
     * 获得害虫检查单号
     * @param map
     * @param jcsj
     * @return
     */
    String getJcd(Map<String, Object> map, String jcsj);

    void add(TCcdata tCcdata,TCcvalue tCcvalue);

    void update(TCcdata tCcdata,TCcvalue tCcvalue);

    List<TCcdata> getInsectPestDeatil(TCcdataExample example);

    /**
     * 查询一条测虫数据
     * @param id 数据ID
     * @return
     */
    TCcdata getByIdTCcData(String id);

    /**
     * 新增或修改虫害检查数据
     * @param insectPests
     */
	void saveOrUpdate(String insectPests) throws Exception;
}
