package com.chinaitop.depot.storage.service;

import com.alibaba.fastjson.JSONArray;
import com.chinaitop.depot.storage.model.StorageQualitycheck;
import com.chinaitop.depot.storage.model.StorageQualitycheckExample;
import com.chinaitop.depot.storage.model.StorageQualitycheckInspectionExample;
import com.chinaitop.depot.storage.model.StorageQualitycheckSon;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

public interface StorageQualitycheckService {

	/**
	 * 按条件查询qualitycheck列表
	 *
	 * @param example
	 * @return
	 */
	List<StorageQualitycheck> findByCondition(StorageQualitycheckExample example);

	/**
	 * 条件查询qualitycheck列表
	 *
	 * @param example
	 * @return
	 */
	List<StorageQualitycheck> queryByQualitycheck(StorageQualitycheck example);

	/**
	 * 新增qualitycheck信息
	 *
	 * @param qualitycheck
	 */
	void save(StorageQualitycheck qualitycheck, String qualityInspection);

	/**
	 * 新增qualitycheck字表信息
	 *
	 * @param qualitycheckone
	 */
	void saveOne(StorageQualitycheckSon qualitycheckone);

	/**
	 * 根据id查询数据
	 *
	 * @param id
	 * @return
	 */
	Map<String, Object> loadDataById(Integer id);

	/**
	 * 根据主键id删除数据
	 *
	 * @param id
	 */
	void remove(int id);

    /**
     * @param qualitycheck
     * @return
     */
    List<StorageQualitycheck> getHouseOrWareList(
            StorageQualitycheck qualitycheck);

    /**
     * @param id
     * @return
     */
    String getQualityStandardStr(Integer id);

	/**
	 * 查询第三方检查列表
	 * @param qualitycheck
	 * @return
	 */
	List<StorageQualitycheck> getThirdCheckList(StorageQualitycheck qualitycheck);
	/**
	 * 查询粮情专卡中粮食质量检测记录
	 * @param qualitycheck
	 * @return
	 */
	List<StorageQualitycheck> getQualitycheckListByFoodbasicinfoCheck(StorageQualitycheck qualitycheck,Integer foodbasicinfoId);

	void setQualityCheckByHistoryStatus (Integer houseId, Integer warehouseId);
	List<Map<String,Object>> getStoreQualityList(Integer orgId);
	List<Map<String,Object>> getTrdStoreQualityList();

	List<StorageQualitycheck> getDataByZJId(Map<String, Object> paramMap);


	/**
	 * 取出封仓需要的数据
	 * @param qualityCheckExample
	 * @return
	 */
	List<StorageQualitycheck> queryByQualitycheckData(StorageQualitycheck qualityCheckExample);

	/**
	 * 查看business_store_ware_detail中是否有数据
	 * @param qualityCheckExample
	 * @return
	 */
	List<StorageQualitycheck> queryByQualitycheckusiness(StorageQualitycheck qualityCheckExample);

	/**
	 * 库点同步 - 质检信息主表
	 * @return
	 */
    List<Map<String,Object>> getAllQualityMain(Map<String, Object> paramMap);

	/**
	 * 库点同步 - 质检信息明细
	 * @return
	 */
	List<Map<String, Object>> getAllQualityInfo(Map<String, Object> paramMap);

	/**
	 * 库点同步 - 粮食库存
	 * @return
	 */
    List<Map<String, Object>> getAllFoodStocks(Map<String, Object> paramMap);


    //获取仓房
    JSONArray getHouseIdAll(Integer orgId);

	Map<String, Object> getcheckByIds(Integer id);

	Integer findId();

	int deleteStorageQualitycheckInspection(StorageQualitycheckInspectionExample example);
}
