package com.chinaitop.depot.storage.service;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.chinaitop.depot.storage.model.StorageQualitystandardMain;

public interface StorageQualitystandardMainService {

	/**
	 * 数据集列表
	 * @param lspz
	 * @return
	 * @throws Exception
	 */
	public List<StorageQualitystandardMain> getList(HttpServletRequest request, Integer lspz) throws Exception;

	/**
	 * 查询一条质量标准配置数据
	 * 
	 * @param id 数据ID
	 * @return
	 * @throws Exception
	 */
	public Map<String, Object> findByIdObj(String id) throws Exception;

	/**
	 * 查询一条质量标准配置数据
	 * 
	 * @param request
	 * @param obj_main
	 * @param obj
	 * @throws Exception
	 */
	public void saveOrUpdate(HttpServletRequest request, String obj_main, String obj) throws Exception;

	/**
	 * 初始化对应品种的化验项初始数据
	 * 
	 * @param lspz 粮油品种
	 * @return
	 * @throws Exception
	 */
	public Map<String, Object> initObj(Integer lspz) throws Exception;

	/**
	 * 删除一条质量标准配置数据
	 * 
	 * @param id
	 */
	public void delete(String id) throws Exception;

	/**
	 * 根据粮油品种查询对应的最新的质量标准配置数据
	 * 
	 * @param lspz 粮食品种
	 * @return
	 */
	public Map<String, Object> findLspzObjs(Integer lspz) throws Exception;
}
