package com.chinaitop.depot.storage.service;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.chinaitop.depot.storage.model.StorageWaterCheck;
import com.chinaitop.depot.storage.model.StorageWaterCheckExample;

public interface StorageWarterCheckService {

	/**
	 * 按条件查询数据集合
	 * 
	 * @param example
	 * @return
	 */
	public List<StorageWaterCheck> findCondition(StorageWaterCheckExample example);

	/**
	 * 按ID查询数据对象
	 * 
	 * @param id
	 * @return
	 */
	public StorageWaterCheck findbyidStorageWaterCheck(String id);

	/**
	 * 更新水分检验数据
	 * 
	 * @param storageWaterCheckJson
	 * @param storageWarterFixedPointJson
	 * @param storageWarterMobilePointJson
	 * @return
	 */
	public Map<String, Object> update(HttpServletRequest request, String storageWaterCheckJson, String storageWarterFixedPointJson,
			String storageWarterMobilePointJson);

	/**
	 * 删除水分检验表数据
	 * 
	 * @param id
	 */
	public void delete(String id);

	/**
	 * 删除一条固定点或机动点的数据
	 * 
	 * @param id
	 * @param dataType
	 */
	public void deleteFlt(String id, Integer dataType);

	/**
	* 按条件查询主表数据集合
	 *
	 * @param example
	 * @return
			 */
	public List<StorageWaterCheck> findWarterData(StorageWaterCheckExample example);
}
