package com.chinaitop.depot.storage.service.impl;

import com.alibaba.fastjson.JSONObject;

import com.chinaitop.depot.storage.mapper.ClearanceConfirmationMapper;
import com.chinaitop.depot.storage.mapper.WarehouseSealingRecordMapper;
import com.chinaitop.depot.storage.model.ClearanceConfirmation;
import com.chinaitop.depot.storage.model.StorageStorehouseBusiness;
import com.chinaitop.depot.storage.model.WarehouseSealingRecord;
import com.chinaitop.depot.storage.model.vo.WareHouseVO;
import com.chinaitop.depot.storage.service.ClearanceConfirmationService;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.sun.javafx.collections.MappingChange;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
public class ClearanceConfirmationServiceImpl implements ClearanceConfirmationService {

    @Resource
    private ClearanceConfirmationMapper ClearanceConfirmationMapper;

    @Resource
    private WarehouseSealingRecordMapper WarehouseSealingRecordMapper;




    @Override
    public List<ClearanceConfirmation> getList(Map<String, Object> map) {
        return ClearanceConfirmationMapper.getCleConList(map);
    }

    @Override
    public ClearanceConfirmation findByCleCon(Integer id) {
        return ClearanceConfirmationMapper.findByCleCon(id);
    }

    @Override
    public Map<String, Object> saveOrUpdate(HttpServletRequest request, String clearanceConfirmationJson, String userInfo) throws Exception {
        Map<String, Object> modelMap = new HashMap<String, Object>();
        JSONObject user = null;
        JSONObject org = null;
        Integer orgId = null;
        String userName = "";
        Map<String, Object> modelMap1 = new HashMap<String, Object>();

        if (null != userInfo && !"".equals(userInfo)) {
            user = JSONObject.parseObject(userInfo);
            orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
            userName = user.get("username") == null?"":user.get("username").toString();
            modelMap1.put("orgId", orgId);
        }

        //获取单位信息
        String orgInfo = ObjectUtils.toString(request.getSession().getAttribute("orgInfo"),"");
        String dwbm = "";
        String ajbm ="";
        if (null != orgInfo && !"".equals(orgInfo)) {
            org = JSONObject.parseObject(orgInfo);
            dwbm = org.get("creditCode") == null?"":org.get("creditCode").toString();
        }

        LocalDate currentDate = LocalDate.now();
        DateTimeFormatter formatter1 = DateTimeFormatter.ofPattern("yyyyMMdd");
        String formattedDate = currentDate.format(formatter1);
        Date date = new Date();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        ClearanceConfirmation ClearanceConfirmation = (ClearanceConfirmation) mapper.readValue(clearanceConfirmationJson, ClearanceConfirmation.class);
        if (ClearanceConfirmation.getId() == null) {
            //根据货位查询同一货位编码
            WareHouseVO wareHouseVO= WarehouseSealingRecordMapper.selectTyhwbm(Integer.parseInt(ClearanceConfirmation.getWarehouseId()));

            modelMap1.put("cqqrdh",ClearanceConfirmation.getCqqrdh());
            List<ClearanceConfirmation> clearanceConfirmation = ClearanceConfirmationMapper.findByCleConList(modelMap1);
            if(clearanceConfirmation.size()>0){
                modelMap.put("message", "出清确认单号已经存在");
                return modelMap;
            }
            ClearanceConfirmation clearanceConfirmation1=  ClearanceConfirmationMapper.selectByCqqrd(ClearanceConfirmation.getWarehouseId());
            if(clearanceConfirmation1!=null){

                String fcqrd =clearanceConfirmation1.getCqqrdh();

                int startIndex =fcqrd.length() - 11; // 假设20240909开始的位置是从字符串末尾数第15个字符开始
                // 要截取的结束位置
                int endIndex = fcqrd.length() - 3; // 假设20240909结束的位置是从字符串末尾数第9个字符结束

                // 使用substring方法进行截取
                String extractedDate = fcqrd.substring(startIndex, endIndex);
                // 当前时间

                // 将字符串转换为日期对象
                String specificDateStr = extractedDate;
                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMMdd");
                LocalDate specificDateObj = LocalDate.parse(specificDateStr, formatter);
                LocalDate today = LocalDate.now();

                if (formattedDate.equals(extractedDate)){
                    // 使用正则表达式提取后三位数字
                    Pattern pattern = Pattern.compile("(\\d{3})$");
                    Matcher matcher = pattern.matcher(fcqrd);
                    if (matcher.find()) {
                        String lastThreeDigits = matcher.group(1);

                        // 将后三位数字转换为整数并加1
                        int incrementedValue = Integer.parseInt(lastThreeDigits) + 1;

                        // 将加1后的整数转换回三位数字字符串，保持前导零
                        String incrementedDigits = String.format("%03d", incrementedValue);

                        // 将原字符串的后三位替换为加1后的三位数字
                        fcqrd = fcqrd.replaceFirst(pattern.pattern(), incrementedDigits);
                        ClearanceConfirmation.setCqqrdh(fcqrd);
                    }
                }else{
                    StringBuffer sbf = new StringBuffer();
                    sbf.append(wareHouseVO.getTyhwbm());
                    sbf.append(specificDateObj);
                    sbf.append("001");
                    ClearanceConfirmation.setCqqrdh(sbf.toString().trim());
                }

            }else{
                StringBuffer sbf = new StringBuffer();
                sbf.append(wareHouseVO.getTyhwbm());
                sbf.append(formattedDate);
                sbf.append("001");
                ClearanceConfirmation.setCqqrdh(sbf.toString().trim());
            }






            ClearanceConfirmation.setCreatename(userName);
            ClearanceConfirmation.setCreatedate(date);
            ClearanceConfirmation.setUpdatename(userName);
            ClearanceConfirmation.setUpdatedate(date);
            ClearanceConfirmation.setZhgxsj(date);
            ClearanceConfirmation.setCzbz("i");
            ClearanceConfirmationMapper.insert(ClearanceConfirmation);
        } else {
            ClearanceConfirmation.setUpdatename(userName);
            ClearanceConfirmation.setUpdatedate(date);
            ClearanceConfirmation.setZhgxsj(date);
            ClearanceConfirmation.setCzbz("u");
            ClearanceConfirmationMapper.updateByPrimaryKey(ClearanceConfirmation);
        }
        modelMap.put("status", "success");

        return modelMap;
    }


    public void updateBasicStorehouse(ClearanceConfirmation ClearanceConfirmation){
        ClearanceConfirmationMapper.updateByPrimaryKey(ClearanceConfirmation);
    }

    @Override
    public List<StorageStorehouseBusiness> findStorehouse(Integer orgId) {
        System.out.print(ClearanceConfirmationMapper.findStorehouseList(orgId));
        return ClearanceConfirmationMapper.findStorehouseList(orgId);
    }

    @Override
    public List<StorageStorehouseBusiness> findByWarehouse(Integer storehouseId) {
        return ClearanceConfirmationMapper.findByWarehouseList(storehouseId);
    }
}
