package com.chinaitop.depot.storage.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.storage.mapper.StorageChangeStoragehouseDefaultMapper;
import com.chinaitop.depot.storage.mapper.StorageChangeStoragehouseRopMapper;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseDefault;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseDefaultExample;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseRop;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseRopExample;
import com.chinaitop.depot.storage.service.FeignAgileService;
import com.chinaitop.depot.storage.service.FeignBasicService;
import com.chinaitop.depot.storage.service.StorageChangeStoragehouseRopService;
@Service
public class StorageChangeStoragehouseRopServiceImpl implements StorageChangeStoragehouseRopService {
	
	@Resource
	private StorageChangeStoragehouseRopMapper storageChangeStoragehouseRopMapper;
	@Resource
	private StorageChangeStoragehouseDefaultMapper storageChangeStoragehouseDefaultMapper;
	@Resource
	private FeignBasicService feignBasicService;
	@Resource
	private FeignAgileService feignAgileService;
	/*
	 * 倒仓列表查询
	 */

	@Override
	public List<StorageChangeStoragehouseDefault> selectByExample(
			StorageChangeStoragehouseDefaultExample storageChangeStoragehouseDefaultexample) {
		return storageChangeStoragehouseDefaultMapper.selectByExample(storageChangeStoragehouseDefaultexample);
	}

	@Override
	public List<StorageChangeStoragehouseRop> selectByExample(
			StorageChangeStoragehouseRopExample storageChangeStoragehouseRopexample) {
		return storageChangeStoragehouseRopMapper.selectByExample(storageChangeStoragehouseRopexample);
	}

	@Override
	public void insertChangeStorageHouse(StorageChangeStoragehouseRop storageChangeStoragehouseRop) {
		storageChangeStoragehouseRopMapper.insertSelective(storageChangeStoragehouseRop);
		
	}

	@Override
	public Map<String, Object> add(String change) {
		Map<String, Object> modelMap = new HashMap<String, Object>();
        try {
            
            // JSON字符串转对象
            JSONObject jsonObject = JSONObject.parseObject(change);
            StorageChangeStoragehouseDefault storageChangeStoragehouseDefault = new StorageChangeStoragehouseDefault();
            storageChangeStoragehouseDefault.setChangehouseNo(jsonObject.getString("changehouseNo")); //接收虚拟倒仓通知单编号
        	storageChangeStoragehouseDefault.setApplyNo(jsonObject.getString("applyNo"));   //申请单号
            String applyFirmName = storageChangeStoragehouseDefaultMapper.selectOrgName(jsonObject.getString("applyFirm"));
        	storageChangeStoragehouseDefault.setApplyFirm(applyFirmName); //申请倒仓企业
        	storageChangeStoragehouseDefault.setApplyTime(jsonObject.getDate("apply_time")); //申请倒仓时间
        	storageChangeStoragehouseDefault.setBitWeigh("需要称重"); //  是否称重
        	storageChangeStoragehouseDefault.setCreateTime(jsonObject.getDate("createTime")); //接收时间
            storageChangeStoragehouseDefault.setOverTime(jsonObject.getDate("over_time"));  //结束时间
        	storageChangeStoragehouseDefault.setFoodNumber(jsonObject.getString("foodNumber")); //粮食数量
            storageChangeStoragehouseDefault.setOperStaff(jsonObject.getString("operStaff")); //操作人员
        	storageChangeStoragehouseDefault.setOutAfter(jsonObject.getString("out_after")); //倒出后保管方式
        	storageChangeStoragehouseDefault.setOutBefore(jsonObject.getString("out_before")); //倒出前保管方式
        	
            //根据倒入仓房编码查询倒入仓房、货位、组织机构数据
        	 String hwbmin = jsonObject.getString("cfbmin");
             Map<String, Object> inWareDataMap = feignBasicService.getWareDataByHwbm(hwbmin);
             Integer houseId = (Integer) inWareDataMap.get("houseId");
             Map<String, Object> inhouseDataMap = feignBasicService.getStoreDataByHouseId(houseId);
             String inStorehouseName = (String) inhouseDataMap.get("StorehouseName");
             //货位
             Integer wareHouseId = (Integer) inWareDataMap.get("wareHouseId");
             String wareHouseName = (String) inWareDataMap.get("warehouseName");
             Integer orgId = (Integer) inWareDataMap.get("orgId");
             storageChangeStoragehouseDefault.setIntoStorehouse(houseId); //倒入仓房
             storageChangeStoragehouseDefault.setIntoStorehouseName(inStorehouseName); //倒入仓房名称
             //货位
             storageChangeStoragehouseDefault.setIntoWarehouse(wareHouseId); //倒入货位
             storageChangeStoragehouseDefault.setIntoWarehouseName(wareHouseName); //倒入货位名称
             storageChangeStoragehouseDefault.setOrgId(orgId);  //组织id
             //根据倒出仓房编码查询倒出仓房、货位、组织机构数据 
             String hwbmout = jsonObject.getString("cfbmout");
             Map<String, Object> outwareDataMap = feignBasicService.getWareDataByHwbm(hwbmout);
             Integer houseOutId = (Integer) outwareDataMap.get("houseId");
             Map<String, Object> outhouseDataMap = feignBasicService.getStoreDataByHouseId(houseOutId);
             String storehouseName = (String) outhouseDataMap.get("StorehouseName");
             //货位
             Integer wareOutHouseId = (Integer) outwareDataMap.get("wareHouseId");
             String wareOutHouseName = (String) outwareDataMap.get("warehouseName");
             storageChangeStoragehouseDefault.setOutStorehouse(houseOutId); //倒出仓房
             storageChangeStoragehouseDefault.setOutStorehouseName(storehouseName); //倒出仓房名称
             
             storageChangeStoragehouseDefault.setOutWarehouse(wareOutHouseId); //倒出货位
             storageChangeStoragehouseDefault.setOutWarehouseName(wareOutHouseName); //倒出货位名称
             //根据仓房、货位、orgId获取粮食品种等信息
             Map<String, Object> map = feignAgileService.getDateByChHwh(orgId, houseOutId, wareOutHouseId);
             Integer  a = (Integer ) map.get("hwxz"); //粮油性质
			 String grainAttribute = a.toString();
             Integer grainKind = (Integer) map.get("pz"); //品种
             Integer grainDetailKind = (Integer) map.get("mxpz"); //明细品种
             
             storageChangeStoragehouseDefault.setFoodWar(grainKind); //品种
             storageChangeStoragehouseDefault.setDetailWar(grainDetailKind); //明细品种
             storageChangeStoragehouseDefault.setFoodNature(grainAttribute); //粮油性质
             
             storageChangeStoragehouseDefaultMapper.insert(storageChangeStoragehouseDefault);
        	
            modelMap.put("status", "success");
        } catch (Exception e) {
            e.printStackTrace();
            modelMap.put("status", "error");
            modelMap.put("msg", "保存失败！");
        } 
		
		return modelMap;
	}
}
