package com.chinaitop.depot.storage.service.impl;


import com.chinaitop.depot.storage.mapper.StorageDailycheckMapper;
import com.chinaitop.depot.storage.model.StorageDailycheck;
import com.chinaitop.depot.storage.model.StorageDailycheckExample;
import com.chinaitop.depot.storage.service.StorageDailyService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class StorageDailyServiceImpl implements StorageDailyService {

    @Resource
    private StorageDailycheckMapper storageDailycheckMapper;

    @Override
    public List<StorageDailycheck> findStorageDailycheck(StorageDailycheckExample example) {
        return storageDailycheckMapper.selectByExample(example);
    }

    @Override
    public void save(StorageDailycheck dailycheck) {
        if (dailycheck.getId() == null){
            storageDailycheckMapper.insertSelective(dailycheck);// 新增数据
        }else{
            storageDailycheckMapper.updateByPrimaryKey(dailycheck);// 修改数据
        }

        //storageDailycheckMapper.insertSelective(dailycheck);
    }

    @Override
    public Map<String, Object> loadDataById(Integer id) {
        Map<String,Object> retMap = new HashMap<String,Object>();
        StorageDailycheck dailycheck = storageDailycheckMapper.selectByPrimaryKey(id);
        retMap.put("dailycheck",dailycheck);
        return retMap;
    }

    @Override
    @Transactional
    public void remove(int id) {
        // 逻辑删除数据
        storageDailycheckMapper.deleteByPrimaryKey(id);
    }
}