package com.chinaitop.depot.storage.service.impl;

import com.chinaitop.depot.storage.mapper.StorageFoodbasicInfoLocationMapper;
import com.chinaitop.depot.storage.model.StorageFoodbasicInfoLocation;
import com.chinaitop.depot.storage.model.StorageFoodbasicInfoLocationExample;
import com.chinaitop.depot.storage.service.StorageFoodbasicInfoLocationService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author sunhongbing
 * @Date 2017/10/20
 */
@Service
public class StorageFoodbasicInfoLocationServiceImpl implements StorageFoodbasicInfoLocationService {
    @Resource
    private StorageFoodbasicInfoLocationMapper foodbasicInfoLocationMapper;
    @Override
    public List<StorageFoodbasicInfoLocation> queryByFoodbasicInfoLocation(StorageFoodbasicInfoLocation location) {
        return foodbasicInfoLocationMapper.queryByExample(location);
    }

    @Override
    public void save(StorageFoodbasicInfoLocation foodbasicInfoLocation) {
        if (foodbasicInfoLocation.getId() == null)
            foodbasicInfoLocationMapper.insert(foodbasicInfoLocation);//新增数据
        else
            foodbasicInfoLocationMapper.updateByPrimaryKey(foodbasicInfoLocation);//修改数据
    }

    @Override
    public StorageFoodbasicInfoLocation loadDataById(int id) {
        return foodbasicInfoLocationMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<StorageFoodbasicInfoLocation> getFoodbasicInfoLocationByWarehouseCode(Integer houseId, Integer wareHouseId) {
        StorageFoodbasicInfoLocationExample example = new StorageFoodbasicInfoLocationExample();
        StorageFoodbasicInfoLocationExample.Criteria criteria = example.createCriteria();
    	criteria.andHouseIdEqualTo(houseId);
    	criteria.andWarehouseIdEqualTo(wareHouseId);
    	return foodbasicInfoLocationMapper.selectByExample(example);
    }
}
