package com.chinaitop.depot.storage.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.storage.mapper.BusinessFileMapper;
import com.chinaitop.depot.storage.mapper.StorageKcglJkqyqApplyDefaultMapper;
import com.chinaitop.depot.storage.mapper.StorageKcglJkqyqDefaultMapper;
import com.chinaitop.depot.storage.model.BusinessFile;
import com.chinaitop.depot.storage.model.BusinessFileExample;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefault;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqApplyDefaultExample;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqDefault;
import com.chinaitop.depot.storage.model.StorageKcglJkqyqDefaultExample;
import com.chinaitop.depot.storage.model.BusinessFileExample.Criteria;
import com.chinaitop.depot.storage.service.StorageKcglJkqyqApplyDefaultService;
@Service
public class StorageKcglJkqyqApplyDefaultServiceImpl implements StorageKcglJkqyqApplyDefaultService {

	 @Resource
	 private StorageKcglJkqyqDefaultMapper storageKcglJkqyqDefaultMapper;
	 
	 @Autowired
	 private BusinessFileMapper fileMapper;
	 
	 @Resource
	 private StorageKcglJkqyqApplyDefaultMapper storageKcglJkqyqApplyDefaultMapper;

	@Override
	public List<StorageKcglJkqyqDefault> findByList(StorageKcglJkqyqDefaultExample example) {
		return storageKcglJkqyqDefaultMapper.selectByExample(example);
	}

	@Override
	public void addDataKcglJkqyqDefault(StorageKcglJkqyqDefault dataKcglJkqyqDefault) {
		storageKcglJkqyqDefaultMapper.insertSelective(dataKcglJkqyqDefault);
	}

	@Override
	public void addDataKcglJkqyqDefault1(StorageKcglJkqyqApplyDefault dataKcglJkqyqDefault1) {
		storageKcglJkqyqApplyDefaultMapper.insertSelective(dataKcglJkqyqDefault1);
	}

	@Override
	public void updateDataKcglJkqyqDefault(StorageKcglJkqyqDefault dataKcglJkqyqDefault) {
		storageKcglJkqyqDefaultMapper.updateByPrimaryKeySelective(dataKcglJkqyqDefault);
	}

	@Override
	public void updateDataKcglJkqyqDefault1(StorageKcglJkqyqApplyDefault dataKcglJkqyqDefault1) {
		storageKcglJkqyqApplyDefaultMapper.updateByPrimaryKeySelective(dataKcglJkqyqDefault1);
	}

	@Override
	public List<StorageKcglJkqyqDefault> selectByExample(StorageKcglJkqyqDefaultExample example) {
		return storageKcglJkqyqDefaultMapper.selectByExample(example);
	}

	@Override
	public List<StorageKcglJkqyqApplyDefault> selectBy1Example(StorageKcglJkqyqApplyDefaultExample detailExamle) {
		return storageKcglJkqyqApplyDefaultMapper.selectByExample(detailExamle);
	}

	@Override
	public void removeOverData(StorageKcglJkqyqDefaultExample example) {
		storageKcglJkqyqDefaultMapper.deleteByExample(example);
	}

	@Override
	public void removeOver1Data(StorageKcglJkqyqApplyDefaultExample detailExamle) {
		storageKcglJkqyqApplyDefaultMapper.deleteByExample(detailExamle);
	}

	@Override
	public void updateJkqIsUpload(StorageKcglJkqyqDefault dataKcglJkq) {
		storageKcglJkqyqDefaultMapper.updateByPrimaryKeySelective(dataKcglJkq);
	}

	@Override
	public void updateJkq1Status(StorageKcglJkqyqApplyDefault dataKcglJkq1) {
		storageKcglJkqyqApplyDefaultMapper.updateByYqsqNo(dataKcglJkq1);
	}

	@Override
	public void updateJkqStatus(StorageKcglJkqyqDefault dataKcglJkqyqDefault) {
		storageKcglJkqyqDefaultMapper.updateByYqsqNo(dataKcglJkqyqDefault);
	}

	/**
	 * 添加文件到business_file
	 */
	@Override
	public void updateFileByFileIdsAndBid(String fileIds, Integer storageId, String fileType) {
		 if (StringUtils.isNotBlank(fileIds) && !"[]".equals(fileIds)) {
            BusinessFile businessFile = new BusinessFile();
            businessFile.setBid(storageId);
            
            BusinessFileExample example = new BusinessFileExample();
            Criteria createCriteria = example.createCriteria();
            // 去除开头结尾.
            fileIds = fileIds.substring(1, fileIds.length());
            fileIds = fileIds.substring(0, fileIds.length() - 1);
            String[] idArray = fileIds.split(",");
            List<Integer> idList = new ArrayList<Integer>();
            for (String id : idArray) {
                idList.add(Integer.parseInt(id));
            }
            
            createCriteria.andIdIn(idList);
            createCriteria.andTypeEqualTo(fileType);
            fileMapper.updateByExampleSelective(businessFile, example);
        }
	}
	@Override
	public List<BusinessFile> getByBid(Integer bid, String fileType, Integer orgId, String order) {
		BusinessFileExample example = new BusinessFileExample();
        Criteria criteria = example.createCriteria();
        
    		if (null != fileType) {
        		criteria.andTypeEqualTo(fileType);
        	}
        	if (null != bid) {
        		criteria.andBidEqualTo(bid);
        	}
        	if (null != orgId) {
        		criteria.andOrgIdEqualTo(orgId);
        	}
        	if (null != order && !"".equals(order)) {
        		example.setOrderByClause(order);
        	}
        
        	return fileMapper.selectByExample(example);
	}

	@Override
	public List<Map<String, Object>> getjkqPlanList(Map<String, Object> map) {
		return storageKcglJkqyqDefaultMapper.getjkqPlanList(map);
	}

	@Override
	public List<Map<String, Object>> getjkqDataDayList(Map<String, Object> countMap) {
		return storageKcglJkqyqDefaultMapper.getjkqDataDayList(countMap);
	}
}
