package com.chinaitop.depot.storage.service.impl;

import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.storage.mapper.StorageOverheadSetMapper;
import com.chinaitop.depot.storage.model.StorageOverheadSet;
import com.chinaitop.depot.storage.model.StorageOverheadSetExample;
import com.chinaitop.depot.storage.service.StorageOverheadSetService;

@Service
public class StorageOverheadSetServiceImpl implements StorageOverheadSetService {

	@Resource
	private StorageOverheadSetMapper storageOverheadSetMapper;

	@Override
	public void insert(StorageOverheadSet storageOverheadSet) {
		storageOverheadSetMapper.insertSelective(storageOverheadSet);
	}

	@Override
	public void update(StorageOverheadSet storageOverheadSet) {
		storageOverheadSetMapper.updateByPrimaryKey(storageOverheadSet);
	}

	@Override
	public List<StorageOverheadSet> findConditions(StorageOverheadSetExample example) {
		return storageOverheadSetMapper.selectByExample(example);
	}

	@Override
	public StorageOverheadSet findByKeyCondition(Integer id) {
		return storageOverheadSetMapper.selectByPrimaryKey(id);
	}

	@Override
	public List<Map<String, Object>> getOverYqDaysList(Map<String, Object> map) {
		return storageOverheadSetMapper.getOverYqDaysList(map);
	}

	@Override
	public List<Map<String, Object>> findOverHeadList(Map<String, Object> map) {
		return storageOverheadSetMapper.getOverHeadTimeList(map);
	}

}
