package com.chinaitop.depot.storage.service.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.storage.mapper.StorageSetMapper;
import com.chinaitop.depot.storage.model.StorageSet;
import com.chinaitop.depot.storage.model.StorageSetExample;
import com.chinaitop.depot.storage.service.StorageSetService;

@Service
public class StorageSetServiceImpl implements StorageSetService {

	@Resource
	private StorageSetMapper storageSetMapper;

	@Override
	public void insert(StorageSet storageSet) {
		storageSetMapper.insert(storageSet);
	}

	@Override
	public void delete(String id) {
		storageSetMapper.deleteByPrimaryKey(id);
	}

	@Override
	public void updateStorageSet(StorageSet storageSet) {
		storageSetMapper.updateByPrimaryKeySelective(storageSet);
	}

	@Override
	public List<StorageSet> findCondition(StorageSetExample example) {
		List<StorageSet> list = storageSetMapper.selectByExample(example);
		return list;
	}

	@Override
	public StorageSet findbyidStorageSet(String id) {
		StorageSet storageSet = storageSetMapper.selectByPrimaryKey(id);
		return storageSet;
	}

	@Override
	public int getDistinckLspz(StorageSetExample example) {
		int count = storageSetMapper.countByExample(example);
		return count;
	}

}
