package com.chinaitop.depot.storage.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.storage.mapper.ClearanceConfirmationMapper;
import com.chinaitop.depot.storage.mapper.GrainSituationCardMapper;
import com.chinaitop.depot.storage.mapper.WarehouseSealingRecordMapper;
import com.chinaitop.depot.storage.model.ClearanceConfirmation;
import com.chinaitop.depot.storage.model.GrainSituationCard;
import com.chinaitop.depot.storage.model.StorageStorehouseBusiness;
import com.chinaitop.depot.storage.model.WarehouseSealingRecord;
import com.chinaitop.depot.storage.model.vo.WareHouseVO;
import com.chinaitop.depot.storage.model.vo.kcswVO;
import com.chinaitop.depot.storage.service.WarehouseSealingRecordService;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
public class WarehouseSealingRecordServiceImpl implements WarehouseSealingRecordService {

    @Resource
    private WarehouseSealingRecordMapper WarehouseSealingRecordMapper;

    @Resource
    private GrainSituationCardMapper grainSituationCardMapper;

    @Resource
    private ClearanceConfirmationMapper clearanceConfirmationMapper;




    @Override
    public List<WarehouseSealingRecord> getList(Map<String, Object> map) {
        return WarehouseSealingRecordMapper.getWarehouseSeaList(map);
    }

    @Override
    public WarehouseSealingRecord findByWarehouseSea(Integer id) {
        return WarehouseSealingRecordMapper.findByWarehouseSea(id);
    }
    @Transactional
    @Override
    public Map<String, Object> saveOrUpdate(HttpServletRequest request, String warehouseSealingRecordJson, String userInfo) throws Exception {
        Map<String, Object> modelMap = new HashMap<String, Object>();
        JSONObject user = null;
        JSONObject org = null;
        Integer orgId = null;
        String userName = "";
        Map<String, Object> modelMap1 = new HashMap<String, Object>();

        if (null != userInfo && !"".equals(userInfo)) {
            user = JSONObject.parseObject(userInfo);
            orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
            userName = user.get("username") == null?"":user.get("username").toString();
            modelMap1.put("orgId", orgId);
        }

        LocalDateTime now = LocalDateTime.now();

        LocalDate currentDate = LocalDate.now();
        DateTimeFormatter formatter1 = DateTimeFormatter.ofPattern("yyyyMMdd");
        String formattedDate = currentDate.format(formatter1);
        Date date=new Date();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        WarehouseSealingRecord WarehouseSealingRecord = (WarehouseSealingRecord) mapper.readValue(warehouseSealingRecordJson, WarehouseSealingRecord.class);
        if (WarehouseSealingRecord.getId() == null) {
            //根据货位查询同一货位编码
            WareHouseVO wareHouseVO= WarehouseSealingRecordMapper.selectTyhwbm(WarehouseSealingRecord.getWarehouseId());
            if(wareHouseVO!=null){
                WarehouseSealingRecord warehouseSealingRecord=  WarehouseSealingRecordMapper.selectFcqrd(WarehouseSealingRecord.getWarehouseId());
               if(warehouseSealingRecord!=null){
//                    if(warehouseSealingRecord.getStatus()==1){
//                        modelMap.put("message", "该货位已经生成粮情卡");
//                        return modelMap;
//
//                    }
                    String fcqrd =warehouseSealingRecord.getFcqrdh();

                    int startIndex =fcqrd.length() - 11; // 假设20240909开始的位置是从字符串末尾数第15个字符开始
                    // 要截取的结束位置
                    int endIndex = fcqrd.length() - 3; // 假设20240909结束的位置是从字符串末尾数第9个字符结束

                    // 使用substring方法进行截取
                    String extractedDate = fcqrd.substring(startIndex, endIndex);
                    // 当前时间

                    // 将字符串转换为日期对象
                    String specificDateStr = extractedDate;
                    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMMdd");
                    LocalDate specificDateObj = LocalDate.parse(specificDateStr, formatter);
                   LocalDate today = LocalDate.now();

                    if (formattedDate.equals(extractedDate)){
                        // 使用正则表达式提取后三位数字
                        Pattern pattern = Pattern.compile("(\\d{3})$");
                        Matcher matcher = pattern.matcher(fcqrd);
                        if (matcher.find()) {
                            String lastThreeDigits = matcher.group(1);

                            // 将后三位数字转换为整数并加1
                            int incrementedValue = Integer.parseInt(lastThreeDigits) + 1;

                            // 将加1后的整数转换回三位数字字符串，保持前导零
                            String incrementedDigits = String.format("%03d", incrementedValue);

                            // 将原字符串的后三位替换为加1后的三位数字
                            fcqrd = fcqrd.replaceFirst(pattern.pattern(), incrementedDigits);
                            WarehouseSealingRecord.setFcqrdh(fcqrd);
                        }
                }else{
                        StringBuffer sbf = new StringBuffer();
                        sbf.append(wareHouseVO.getTyhwbm());
                        sbf.append(specificDateObj);
                        sbf.append("001");
                        WarehouseSealingRecord.setFcqrdh(sbf.toString().trim());
                    }

            }else{
                    StringBuffer sbf = new StringBuffer();
                    sbf.append(wareHouseVO.getTyhwbm());
                    sbf.append(formattedDate);
                    sbf.append("001");
                    WarehouseSealingRecord.setFcqrdh(sbf.toString().trim());
                }
            }

            WarehouseSealingRecord.setCreatename(userName);
            WarehouseSealingRecord.setCreatedate(date);
            WarehouseSealingRecord.setUpdatename(userName);
            WarehouseSealingRecord.setUpdatedate(date);
            WarehouseSealingRecord.setZhgxsj(date);
            WarehouseSealingRecord.setCzbz("i");
            WarehouseSealingRecordMapper.insert(WarehouseSealingRecord);

        } else {
            WarehouseSealingRecord.setUpdatename(userName);
           // WarehouseSealingRecord.setCreatedate(date);
            WarehouseSealingRecord.setUpdatedate(date);
            WarehouseSealingRecord.setZhgxsj(date);
            WarehouseSealingRecord.setCzbz("u");
            WarehouseSealingRecordMapper.updateByPrimaryKey(WarehouseSealingRecord);
        }

        if(WarehouseSealingRecord.getStatus()==1){
            //查询出清确认单时间
            int sum =0;
            Date cqsj=new Date();
            BigDecimal cksl=BigDecimal.valueOf(0.00);
            ClearanceConfirmation clearanceConfirmation = clearanceConfirmationMapper.selectCqqrd(WarehouseSealingRecord.getWarehouseId());
            if(clearanceConfirmation!=null){
                if(clearanceConfirmation.getUpdatedate()==null&&!"".equals(clearanceConfirmation.getUpdatedate())){
                    cqsj= new Date();
                }
                cqsj =clearanceConfirmation.getUpdatedate();
            }


            //查询fcbgz
            Map map =new HashMap<>();
            map.put("warehouseId",WarehouseSealingRecord.getWarehouseId());
            map.put("cqsj",cqsj);
            map.put("fcsj",date);
            Map<String, Double> map1=clearanceConfirmationMapper.selectFcbgz(map);
            if(map1 != null && !map1.isEmpty()){
                if(map1.get("cksl")!=null){
                    cksl =BigDecimal.valueOf(map1.get("cksl"));
                }

            }

            Map<String,BigDecimal> mmap=clearanceConfirmationMapper.getexcessLossQuantity(WarehouseSealingRecord.getWarehouseId());
            Map<String,Object> stoMap =clearanceConfirmationMapper.getStoreHouse(WarehouseSealingRecord.getWarehouseId());
            GrainSituationCard grainSituationCard =new GrainSituationCard();
            grainSituationCard.setCreatedate(date);
            grainSituationCard.setUpdatedate(date);
            grainSituationCard.setWarehouseSealingRecordId(WarehouseSealingRecord.getId());
            grainSituationCard.setFillOrgId(WarehouseSealingRecord.getOrgId());
            grainSituationCard.setKeepOrgId(WarehouseSealingRecord.getOrgId());
            grainSituationCard.setBasicStorehouseId(WarehouseSealingRecord.getBasicStorehouseId());
            grainSituationCard.setBasicUnitAisleId(WarehouseSealingRecord.getBasicUnitAisleId());
            grainSituationCard.setWarehouseId(WarehouseSealingRecord.getWarehouseId());
            grainSituationCard.setGrainGradeId(WarehouseSealingRecord.getGrainGradeId());
            grainSituationCard.setGrainVarietyId(WarehouseSealingRecord.getGrainVarietyId());
            grainSituationCard.setGrainNatureId(WarehouseSealingRecord.getGrainNatureId());
            grainSituationCard.setGrainAreaId(WarehouseSealingRecord.getGrainAreaId());
            grainSituationCard.setLssl(WarehouseSealingRecord.getLssl());
            grainSituationCard.setShnd(WarehouseSealingRecord.getShnd());
            grainSituationCard.setRcsj(WarehouseSealingRecord.getRcsj());
            grainSituationCard.setOutQuantity(cksl);
            grainSituationCard.setFormWarehouseTime(WarehouseSealingRecord.getZhgxsj());
            grainSituationCard.setStorageOrgId(WarehouseSealingRecord.getOrgId());
            BigDecimal getexcessLossQuantity =BigDecimal.valueOf(0.00);
            if(mmap!=null&&!mmap.isEmpty()){
                if(mmap.get("getexcessLossQuantity")!=null){
                    getexcessLossQuantity=mmap.get("getexcessLossQuantity");
                }

            }
            grainSituationCard.setExcessLossQuantity(getexcessLossQuantity);
            grainSituationCard.setGlfs(WarehouseSealingRecord.getGlfs());

            BigDecimal designCapacity =BigDecimal.valueOf(0.00);
            Integer keepingWay =null;
            Integer draftType =null;
            Integer temperatureMeasureType=null;
            Integer storehouseType=null;

                    if(stoMap != null && !stoMap.isEmpty()){
                        if(stoMap.get("designCapacity")!=null){
                            System.out.println("============================="+stoMap.get("designCapacity").toString());
                            designCapacity =(BigDecimal)(stoMap.get("designCapacity"));
                        }
                        if(stoMap.get("keepingWay")!=null){
                            keepingWay=(Integer)(stoMap.get("keepingWay"));
                        }
                        if(stoMap.get("draftType")!=null){
                            draftType =(Integer)(stoMap.get("draftType"));
                        }
                        if(stoMap.get("temperatureMeasureType")!=null){
                            temperatureMeasureType =(Integer)(stoMap.get("temperatureMeasureType"));
                        }
                        if(stoMap.get("storehouseType")!=null){
                            storehouseType =(Integer)(stoMap.get("storehouseType"));
                        }
                    }
            grainSituationCard.setStorehouseType(storehouseType);
            grainSituationCard.setKeepingWay(keepingWay);
            grainSituationCard.setDesignCapacity(designCapacity);
            grainSituationCard.setDrafttype(draftType);
            grainSituationCard.setTemperatureMeasureType(temperatureMeasureType);
            grainSituationCardMapper.insert(grainSituationCard);
        }
        modelMap.put("status", "success");

        return modelMap;
    }


    public void updateBasicStorehouse(WarehouseSealingRecord WarehouseSealingRecord){
        WarehouseSealingRecordMapper.updateByPrimaryKey(WarehouseSealingRecord);
    }

    /**
     * 查询本库区做过出仓检验的的仓房
     * @param orgId
     * @return
     */
    @Override
    public List<StorageStorehouseBusiness> findStorehouse(Integer orgId) {
        List<StorageStorehouseBusiness> storageStorehouseBusinessList= WarehouseSealingRecordMapper.findStorehouseList(orgId);
        return storageStorehouseBusinessList;
    }

    /**
     *
     * @param storehouseId
     * @return
     */
    @Override
    public List<WareHouseVO> findWareHouse(Integer storehouseId) {
        List<WareHouseVO> wareHouseVOList = WarehouseSealingRecordMapper.findWareHouse(storehouseId);
        return wareHouseVOList;
    }

    @Override
    public kcswVO findkcsw(Integer warehouseId) {
        kcswVO wareHouseVO =WarehouseSealingRecordMapper.findkcsw(warehouseId);

        return wareHouseVO;
    }
}
