package com.chinaitop.depot.storage.utils;

import com.alibaba.fastjson.JSON;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DataSynchronization {
	private static String urls = "http://192.168.123.123:14100";
	private static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
	
	/**
	 * 查询质检信息
	 */
	public static List queryQualityInfo() {
		Map<String,Object> params = new HashMap<String,Object>();
		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPostJson(urls+"/qualityInfoList", jsonStr);
		System.out.print(result);
		params = (Map<String, Object>) JSON.parseArray(result, Map.class);
		List list = (List)params.get("data");
		return list;
	}
	
	/**
	 * 质检信息同步---插入
	 */
	public static void insertQuality(Map<String,Object> qualityMap) {
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("bz","");													//无（文档）
		params.put("bzyqpdgz",qualityMap.get("bzyqpdgz")); 						//标准依据
		params.put("ccqyfzr","");												//无（文档）
		params.put("ccqylxdh","");											 	//无（文档）
		params.put("chfsqk","");												//无（文档）
		params.put("cljs","");													//无（文档）
		params.put("createDate",format.format(new Date()));						//创建时间
		params.put("creator",""); 												//创建者
		params.put("creatorCode","");											//创建人编号
		params.put("dxpd","");													//单项判断
		params.put("jcrbm","");													//检测人编码
		params.put("jcrmc",qualityMap.get("jcrmc"));							//检验人
		params.put("jybzbh","");												//检测标准id
		params.put("jydh","");													//检验单号
		params.put("jyjg",qualityMap.get("jyjg"));								//检验结果
		params.put("jyjl","");													//无（文档）
		params.put("jyxm",qualityMap.get("jyxm"));								//检验项目
		params.put("lcsymc","");												//无（文档）
		//params.put("refreshTime",qualitycheck.getUpdatetime()==null?"":format.format(qualitycheck.getUpdatetime()));// 刷新时间
		params.put("refresher","");												//刷新人
		params.put("refresherCode","");											//刷新人编码
		params.put("remark",qualityMap.get("remark"));							//备注
		params.put("spaqxm","");												//无（文档）
		params.put("status",qualityMap.get("status"));							//状态
		params.put("sxh",0);													//顺序号
		params.put("syqk","");													//无（文档）
		params.put("syyjmc","");												//无（文档）
		params.put("tyfzrqz","");												//无（文档）
		params.put("tyjg","");													//无（文档）
		params.put("tyxxfj","");												//无（文档）
		params.put("zjbgfj","");												//无（文档）
		params.put("zjsysj","");												//无（文档）
		params.put("zjxxid","");												//质检信息
		params.put("zkje",qualityMap.get("zkje"));								//增扣金额（元）
		params.put("zklbl",0);													//增扣量比例
		params.put("zksl",0);													//增扣数量（kg）
		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPostJson(urls+"/qualityInfo", jsonStr);
		System.out.print(result);
	}
	
	/**
	 * 质检信息同步---更新
	 */
	public static void updateQuality(Map<String,Object> params,Map<String,Object> qualityMap) {
		params.put("bz","");													//无（文档）
		params.put("bzyqpdgz",qualityMap.get("bzyqpdgz")); 						//标准依据
		params.put("ccqyfzr","");												//无（文档）
		params.put("ccqylxdh","");											 	//无（文档）
		params.put("chfsqk","");												//无（文档）
		params.put("cljs","");													//无（文档）
		params.put("createDate",format.format(new Date()));						//创建时间
		params.put("creator",""); 												//创建者
		params.put("creatorCode","");											//创建人编号
		params.put("dxpd","");													//单项判断
		params.put("jcrbm","");													//检测人编码
		params.put("jcrmc",qualityMap.get("jcrmc"));							//检验人
		params.put("jybzbh","");												//检测标准id
		params.put("jydh","");													//检验单号
		params.put("jyjg",qualityMap.get("jyjg"));								//检验结果
		params.put("jyjl","");													//无（文档）
		params.put("jyxm",qualityMap.get("jyxm"));								//检验项目
		params.put("lcsymc","");												//无（文档）
		//params.put("refreshTime",qualitycheck.getUpdatetime()==null?"":format.format(qualitycheck.getUpdatetime()));// 刷新时间
		params.put("refresher","");												//刷新人
		params.put("refresherCode","");											//刷新人编码
		params.put("remark",qualityMap.get("remark"));							//备注
		params.put("spaqxm","");												//无（文档）
		params.put("status",qualityMap.get("status"));							//状态
		params.put("sxh",0);													//顺序号
		params.put("syqk","");													//无（文档）
		params.put("syyjmc","");												//无（文档）
		params.put("tyfzrqz","");												//无（文档）
		params.put("tyjg","");													//无（文档）
		params.put("tyxxfj","");												//无（文档）
		params.put("zjbgfj","");												//无（文档）
		params.put("zjsysj","");												//无（文档）
		params.put("zjxxid","");												//质检信息
		params.put("zkje",qualityMap.get("zkje"));								//增扣金额（元）
		params.put("zklbl",0);													//增扣量比例
		params.put("zksl",0);													//增扣数量（kg）

		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPutJson(urls+"/qualityInfo", jsonStr);
		System.out.print(result);
	}
	
	/**
	 * 库点信息同步---删除
	 */
	/*public static void orgInfoSynchronizationDelete(OrgInfo orgInfo) {
		Map<String,String> params = new HashMap<String,String>();
		params.put("kddm",ObjectUtils.toString(orgInfo.getOrgId(),""));
		//json对象转换成json字符串
		String result = HttpClientUtil.doDelete(urls+"/sinkpoint", params);
		System.out.print(result);
	}*/


	/**
	 * 查询质检信息主表
	 */
	public static List queryQualityMain() {
		Map<String,Object> params = new HashMap<String,Object>();
		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPostJson(urls+"/qualityMainList", jsonStr);
		System.out.print(result);
		params = (Map<String, Object>) JSON.parseArray(result, Map.class);
		List list = (List)params.get("data");
		return list;
	}

	/**
	 * 质检信息同步---插入
	 */
	public static void insertQualityMain(Map<String,Object> qualityMap) {
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("bzrbm","");      									//编制人编码
		params.put("bzrmc","");                        					//编制人名称
		params.put("bzsj","");											//编制时间
		params.put("checkRemark",qualityMap.get("checkRemark"));		//检验备注-
		params.put("createDate",format.format(new Date()));				//创建时间-
		params.put("creator","");										//创建者
		params.put("creatorCode","");									//创建人编号
	 	params.put("dbsldw",qualityMap.get("dbsldw"));					//代表数量单位（kg）-
		params.put("ggxh","");											//规格型号
		params.put("hwbm","");											//货位编号（仓房编码+01 两位序号）location_num-
		params.put("jydwdm","");										//检验单位
		params.put("jydwmc",qualityMap.get("jydwmc"));					//检验单位名称-
		params.put("jyjg",qualityMap.get("jyjg"));						//检验结果-
		params.put("jylbbm",qualityMap.get("jylbbm"));					//检验类别-
		params.put("jypdyj",qualityMap.get("jypdyj"));					//检验标准依据-
		params.put("jyrq",qualityMap.get("jyrq"));						//检验时间-
		params.put("jyyj","01");
		params.put("lscd",qualityMap.get("lscd"));						//产地-
		params.put("lsdjbm",qualityMap.get("lsdjbm"));					//等级-
		params.put("lsdjmc","");										//等级名称
		params.put("lsgb","");											//粮食国别
		params.put("lspzbm",qualityMap.get("lspzbm"));					//粮食品种编码-
		params.put("lspzmc",qualityMap.get("lspzmc"));					//粮食品种名称-
		params.put("lyfs",qualityMap.get("lyfs"));						//来样方式 -
		params.put("qfrbm","");											//签发人编码
		params.put("qfrmc",qualityMap.get("qfrmc"));					//签发人名称 -
		params.put("qfsj","");											//签发时间
		params.put("qydbh","");											//样品单编号
		params.put("qydd","");											//签样地点
		params.put("qyrbm","");											//签样人编码
		params.put("qyrmc","");											//签样人名称
		params.put("refreshTime",format.format(qualityMap.get("refreshTime")));	//刷新时间
		params.put("refresher","");										//刷新着
		params.put("refresherCode","");									//刷新人编号
		params.put("remark",qualityMap.get("remark"));					//备注
		params.put("rknx",0);											//入库年限
		params.put("scrqpc","");										//生产日期/批次
		params.put("shnd",qualityMap.get("shnd"));						//收获年度-
		params.put("shrbm","");											//审核人编码
		params.put("shrmc","");											//审核人名称
		params.put("shsj","");											//审核时间
		params.put("ssajbh",qualityMap.get("shnd"));					//所属廒间编号（仓房编码+001 三位序号）-
		params.put("ssajmc","");										//所属廒间名称
		params.put("sscfbh",qualityMap.get("sscfbh"));					//所属仓房编码（库点编码+001 三位序号）-
		params.put("sscfmc","");										//所属仓房名称
		params.put("sskddm",qualityMap.get("sskddm"));					//所属库点编码  -
		params.put("sskdmc",qualityMap.get("sskdmc"));					//所属库点名称  -
		params.put("ssqydm",qualityMap.get("ssqydm"));					//所属企业代码 （统一社会信用代码）-
		params.put("ssyqmc",qualityMap.get("ssyqmc"));					//所属企业名称  -
		params.put("status",qualityMap.get("status"));					//状态 -
		params.put("wtdwdm","");										//委托单位代码 （统一社会信用代码）
		params.put("wtdwmc","");										//委托单位名称
		params.put("ypsldw",0);											//样品数量单位（kg）
		params.put("ypztbs","");										//样品状态标识
		params.put("zjbgbh","");										//质检报告编号
		params.put("zjbgmc","");										//质检报告名称
		params.put("zjxxid","");										//质检信息id ZJ20190802000001
		params.put("zsbm","");											//证书编码
		params.put("zxcpbzh","");										//执行产品标准号
		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPostJson(urls+"/qualityMain", jsonStr);
		System.out.print(result);
	}

	/**
	 * 质检信息同步---更新
	 */
	public static void updateQualityMain(Map<String,Object> params,Map<String,Object> qualityMap) {
		params.put("bzrbm","");      									//编制人编码
		params.put("bzrmc","");                        					//编制人名称
		params.put("bzsj","");											//编制时间
		params.put("checkRemark",qualityMap.get("checkRemark"));		//检验备注-
		params.put("createDate",format.format(new Date()));				//创建时间-
		params.put("creator","");										//创建者
		params.put("creatorCode","");									//创建人编号
		params.put("dbsldw",qualityMap.get("dbsldw"));					//代表数量单位（kg）-
		params.put("ggxh","");											//规格型号
		params.put("hwbm","");											//货位编号（仓房编码+01 两位序号）location_num-
		params.put("jydwdm","");										//检验单位
		params.put("jydwmc",qualityMap.get("jydwmc"));					//检验单位名称-
		params.put("jyjg",qualityMap.get("jyjg"));						//检验结果-
		params.put("jylbbm",qualityMap.get("jylbbm"));					//检验类别-
		params.put("jypdyj",qualityMap.get("jypdyj"));					//检验标准依据-
		params.put("jyrq",qualityMap.get("jyrq"));						//检验时间-
		params.put("jyyj","01");
		params.put("lscd",qualityMap.get("lscd"));						//产地-
		params.put("lsdjbm",qualityMap.get("lsdjbm"));					//等级-
		params.put("lsdjmc","");										//等级名称
		params.put("lsgb","");											//粮食国别
		params.put("lspzbm",qualityMap.get("lspzbm"));					//粮食品种编码-
		params.put("lspzmc",qualityMap.get("lspzmc"));					//粮食品种名称-
		params.put("lyfs",qualityMap.get("lyfs"));						//来样方式 -
		params.put("qfrbm","");											//签发人编码
		params.put("qfrmc",qualityMap.get("qfrmc"));					//签发人名称 -
		params.put("qfsj","");											//签发时间
		params.put("qydbh","");											//样品单编号
		params.put("qydd","");											//签样地点
		params.put("qyrbm","");											//签样人编码
		params.put("qyrmc","");											//签样人名称
		params.put("refreshTime",format.format(qualityMap.get("refreshTime")));	//刷新时间
		params.put("refresher","");										//刷新着
		params.put("refresherCode","");									//刷新人编号
		params.put("remark",qualityMap.get("remark"));					//备注
		params.put("rknx",0);											//入库年限
		params.put("scrqpc","");										//生产日期/批次
		params.put("shnd",qualityMap.get("shnd"));						//收获年度-
		params.put("shrbm","");											//审核人编码
		params.put("shrmc","");											//审核人名称
		params.put("shsj","");											//审核时间
		params.put("ssajbh",qualityMap.get("shnd"));					//所属廒间编号（仓房编码+001 三位序号）-
		params.put("ssajmc","");										//所属廒间名称
		params.put("sscfbh",qualityMap.get("sscfbh"));					//所属仓房编码（库点编码+001 三位序号）-
		params.put("sscfmc","");										//所属仓房名称
		params.put("sskddm",qualityMap.get("sskddm"));					//所属库点编码  -
		params.put("sskdmc",qualityMap.get("sskdmc"));					//所属库点名称  -
		params.put("ssqydm",qualityMap.get("ssqydm"));					//所属企业代码 （统一社会信用代码）-
		params.put("ssyqmc",qualityMap.get("ssyqmc"));					//所属企业名称  -
		params.put("status",qualityMap.get("status"));					//状态 -
		params.put("wtdwdm","");										//委托单位代码 （统一社会信用代码）
		params.put("wtdwmc","");										//委托单位名称
		params.put("ypsldw",0);											//样品数量单位（kg）
		params.put("ypztbs","");										//样品状态标识
		params.put("zjbgbh","");										//质检报告编号
		params.put("zjbgmc","");										//质检报告名称
		params.put("zjxxid","");										//质检信息id ZJ20190802000001
		params.put("zsbm","");											//证书编码
		params.put("zxcpbzh","");										//执行产品标准号

		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPutJson(urls+"/qualityMain", jsonStr);
		System.out.print(result);
	}

	/**
	 * 查询粮食库存
	 */
	public static List queryFoodStocksList() {
		Map<String,Object> params = new HashMap<String,Object>();
		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString  (params);
		String result = HttpClientUtil.doPostJson(urls+"/foodStocksList", jsonStr);
		System.out.print(result);
		params = (Map<String, Object>) JSON.parseArray(result, Map.class);
		List list = (List)params.get("data");
		return list;
	}

	/**
	 * 粮食库存同步---插入
	 */
	public static void insertFoodStocks(Map<String,Object> foodStocksMap) {
		Map<String,Object> params = new HashMap<String,Object>();
		params.put("bgybm","");                                 	//保管员编码
		params.put("bgymc",foodStocksMap.get("bgymc"));				//保管员名称 --keeper
		params.put("ccqj","");										//存储期间 --storage_location
		params.put("createDate",format.format(new Date()));			//创建时间
		params.put("creator","");									//创建者
		params.put("creatorCode","");                           	//创建人编号
		params.put("czhddj",foodStocksMap.get("czhddj"));			//财政核定单价 --price
		params.put("fcsj",format.format(foodStocksMap.get("fcsj")));//封仓时间  --input_year
		params.put("fcsl",foodStocksMap.get("fcsl"));				//封仓数量  --number
		params.put("hwbm",foodStocksMap.get("hwbm"));				//货位编号（仓房编码+01 两位序号） --
		params.put("kcxxid",foodStocksMap.get("kcxxid"));			//库存信息id --
		params.put("lqgsdwbm",foodStocksMap.get("lqgsdwbm"));		//粮权归属单位代码 （统一社会信用代码）
		params.put("lqgsdwmc",foodStocksMap.get("lqgsdwmc"));		//粮权归属单位名称 --
		params.put("lsccfsbm","");									//存储方式编码
		params.put("lsccfsmc",foodStocksMap.get("lsccfsmc"));		//存储方式名称 --keep_method
		params.put("lscd",foodStocksMap.get("lscd"));				//粮食产地 --place_of_origin
		params.put("lsdjbm","");									//粮食等级编码（01：一等；02：二等；03：三等；04：四等；05：五等；06：等外）
		params.put("lsdjmc",foodStocksMap.get("lsdjmc"));			//粮食等级名称  --level
		params.put("lsgb","");										//粮食国别
		params.put("lsnd","");										//粮食年度
		params.put("lspzbm",foodStocksMap.get("lspzbm"));			//粮食品种编码 --sub_type
		params.put("lspzmc",foodStocksMap.get("lspzmc"));			//粮食品种名称 --sub_type_detailed
		params.put("lsxzbm",foodStocksMap.get("lsxzbm"));			//粮食性质编码（100：储备粮；110：国家储备粮；111：专项储备粮；112：战略储备粮；120：地方储备粮；121：省级地方储备粮）--quality
		params.put("lsxzmc",foodStocksMap.get("lsxzmc"));			//粮食性质名称 --quality
		params.put("pzbm",foodStocksMap.get("pzbm"));				//品种编码 --sub_type
		params.put("qcsj","");										//清仓时间
		params.put("refreshTime","");								//刷新时间
		params.put("refresher","");									//刷新着
		params.put("refresherCode","");								//刷新人编号
		params.put("remark","");									//备注
		params.put("rksj",format.format(foodStocksMap.get("rksj")));//入库时间 --input_year
		params.put("shnd",foodStocksMap.get("shnd"));				//收获年度 --grow_year
		params.put("ssajbh",foodStocksMap.get("ssajbh"));			//所属廒间编号（仓房编码+001 三位序号）--
		params.put("ssajmc","");									//所属廒间名称
		params.put("sscfbh",foodStocksMap.get("sscfbh"));			//所属仓房编码（库点编码+001 三位序号）--
		params.put("sscfmc",foodStocksMap.get("sscfmc"));			//所属仓房名称 --
		params.put("sskddm","");									//所属库点编码
		params.put("sskdmc",foodStocksMap.get("sskdmc"));			//所属库点名称 --
		params.put("ssyddm","");									//所属企业代码 （统一社会信用代码）
		params.put("ssyqmc","");									//所属企业名称
		params.put("status",foodStocksMap.get("status"));			//状态

		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPostJson(urls+"/foodStocks", jsonStr);
		System.out.print(result);
	}

	/**
	 * 粮食库存同步---更新
	 */
	public static void updateFoodStocks(Map<String,Object> params,Map<String,Object> foodStocksMap) {
		params.put("bgybm","");                                 	//保管员编码
		params.put("bgymc",foodStocksMap.get("bgymc"));				//保管员名称 --keeper
		params.put("ccqj","");										//存储期间 --storage_location
		params.put("createDate",format.format(new Date()));			//创建时间
		params.put("creator","");									//创建者
		params.put("creatorCode","");                           	//创建人编号
		params.put("czhddj",foodStocksMap.get("czhddj"));			//财政核定单价 --price
		params.put("fcsj",format.format(foodStocksMap.get("fcsj")));//封仓时间  --input_year
		params.put("fcsl",foodStocksMap.get("fcsl"));				//封仓数量  --number
		params.put("hwbm",foodStocksMap.get("hwbm"));				//货位编号（仓房编码+01 两位序号） --
		params.put("kcxxid",foodStocksMap.get("kcxxid"));			//库存信息id --
		params.put("lqgsdwbm",foodStocksMap.get("lqgsdwbm"));		//粮权归属单位代码 （统一社会信用代码）
		params.put("lqgsdwmc",foodStocksMap.get("lqgsdwmc"));		//粮权归属单位名称 --
		params.put("lsccfsbm","");									//存储方式编码
		params.put("lsccfsmc",foodStocksMap.get("lsccfsmc"));		//存储方式名称 --keep_method
		params.put("lscd",foodStocksMap.get("lscd"));				//粮食产地 --place_of_origin
		params.put("lsdjbm","");									//粮食等级编码（01：一等；02：二等；03：三等；04：四等；05：五等；06：等外）
		params.put("lsdjmc",foodStocksMap.get("lsdjmc"));			//粮食等级名称  --level
		params.put("lsgb","");										//粮食国别
		params.put("lsnd","");										//粮食年度
		params.put("lspzbm",foodStocksMap.get("lspzbm"));			//粮食品种编码 --sub_type
		params.put("lspzmc",foodStocksMap.get("lspzmc"));			//粮食品种名称 --sub_type_detailed
		params.put("lsxzbm",foodStocksMap.get("lsxzbm"));			//粮食性质编码（100：储备粮；110：国家储备粮；111：专项储备粮；112：战略储备粮；120：地方储备粮；121：省级地方储备粮）--quality
		params.put("lsxzmc",foodStocksMap.get("lsxzmc"));			//粮食性质名称 --quality
		params.put("pzbm",foodStocksMap.get("pzbm"));				//品种编码 --sub_type
		params.put("qcsj","");										//清仓时间
		params.put("refreshTime","");								//刷新时间
		params.put("refresher","");									//刷新着
		params.put("refresherCode","");								//刷新人编号
		params.put("remark","");									//备注
		params.put("rksj",format.format(foodStocksMap.get("rksj")));//入库时间 --input_year
		params.put("shnd",foodStocksMap.get("shnd"));				//收获年度 --grow_year
		params.put("ssajbh",foodStocksMap.get("ssajbh"));			//所属廒间编号（仓房编码+001 三位序号）--
		params.put("ssajmc","");									//所属廒间名称
		params.put("sscfbh",foodStocksMap.get("sscfbh"));			//所属仓房编码（库点编码+001 三位序号）--
		params.put("sscfmc",foodStocksMap.get("sscfmc"));			//所属仓房名称 --
		params.put("sskddm","");									//所属库点编码
		params.put("sskdmc",foodStocksMap.get("sskdmc"));			//所属库点名称 --
		params.put("ssyddm","");									//所属企业代码 （统一社会信用代码）
		params.put("ssyqmc","");									//所属企业名称
		params.put("status",foodStocksMap.get("status"));			//状态

		//json对象转换成json字符串
		String jsonStr = JSON.toJSONString(params);
		String result = HttpClientUtil.doPutJson(urls+"/qualityMain", jsonStr);
		System.out.print(result);
	}

}